(()=>{var __webpack_modules__={"./node_modules/program-language-detector/dist/programLanguageDetector.es.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"LANG\": () => (/* binding */ LANG),\n/* harmony export */   \"detect\": () => (/* binding */ detect),\n/* harmony export */   \"languages\": () => (/* binding */ languages)\n/* harmony export */ });\n/*!\n * program-language-detector v0.0.12\n * (c) 2018-present ULIVZ <chl814@foxmail.com>\n * Released under the MIT License.\n */\n/**\n *  Modified from https://github.com/ts95/lang-detector\n *  Copyright (c) 2015 Toni Sučić, The MIT License (MIT)\n */\n\nvar LANGUAGES = {\n  JavaScript: [\n  // undefined keyword\n  { pattern: /undefined/g, points: 2 },\n  // console.log('ayy lmao')\n  { pattern: /console\\.log( )*\\(/, points: 2 },\n  // Variable declaration\n  { pattern: /(var|const|let)( )+\\w+( )*=?/, points: 2 },\n  // Array/Object declaration\n  { pattern: /(('|\").+('|\")( )*|\\w+):( )*[{\\[]/, points: 2 },\n  // === operator\n  { pattern: /\\===/g, points: 1 },\n  // !== operator\n  { pattern: /!==/g, points: 1 },\n  // Function definition\n  { pattern: /function\\*?(( )+[\\$\\w]+( )*\\(.*\\)|( )*\\(.*\\))/g, points: 1 },\n  // null keyword\n  { pattern: /null/g, points: 1 },\n  // lambda expression\n  { pattern: /\\(.*\\)( )*=>( )*.+/, points: 1 },\n  // (else )if statement\n  { pattern: /(else )?if( )+\\(.+\\)/, points: 1 },\n  // while loop\n  { pattern: /while( )+\\(.+\\)/, points: 1 },\n  // C style variable declaration.\n  { pattern: /(^|\\s)(char|long|int|float|double)( )+\\w+( )*=?/, points: -1 },\n  // pointer\n  { pattern: /(\\w+)( )*\\*( )*\\w+/, points: -1 },\n  // HTML <script> tag\n  { pattern: /<(\\/)?script( type=('|\")text\\/javascript('|\"))?>/, points: -50 },\n  // ES6 import / export\n  { pattern: /(import|export(\\s+)default)\\s+({\\s+[\\w\\s,]+\\s+}|\\w+)\\s+from\\s/, points: 2 },\n  // ES6 arrow function\n  { pattern: /\\([^\\(\\)]{0,}\\)\\s+=>(\\s+{)?/, points: 3 }],\n\n  C: [\n  // Primitive variable declaration.\n  { pattern: /(char|long|int|float|double)( )+\\w+( )*=?/, points: 2 },\n  // malloc function call\n  { pattern: /malloc\\(.+\\)/, points: 2 },\n  // #include <whatever.h>\n  { pattern: /#include (<|\")\\w+\\.h(>|\")/, points: 2, nearTop: true },\n  // pointer\n  { pattern: /(\\w+)( )*\\*( )*\\w+/, points: 2 },\n  // Variable declaration and/or initialisation.\n  { pattern: /(\\w+)( )+\\w+(;|( )*=)/, points: 1 },\n  // Array declaration.\n  { pattern: /(\\w+)( )+\\w+\\[.+\\]/, points: 1 },\n  // #define macro\n  { pattern: /#define( )+.+/, points: 1 },\n  // NULL constant\n  { pattern: /NULL/, points: 1 },\n  // void keyword\n  { pattern: /void/g, points: 1 },\n  // (else )if statement\n  { pattern: /(else )?if( )*\\(.+\\)/, points: 1 },\n  // while loop\n  { pattern: /while( )+\\(.+\\)/, points: 1 },\n  // printf function\n  { pattern: /(printf|puts)( )*\\(.+\\)/, points: 1 },\n  // new Keyword from C++\n  { pattern: /new \\w+/, points: -1 },\n  // Single quote multicharacter string\n  { pattern: /'.{2,}'/, points: -1 },\n  // JS variable declaration\n  { pattern: /var( )+\\w+( )*=?/, points: -1 }],\n\n  'C++': [\n  // Primitive variable declaration.\n  { pattern: /(char|long|int|float|double)( )+\\w+( )*=?/, points: 2 },\n  // #include <whatever.h>\n  { pattern: /#include( )*(<|\")\\w+(\\.h)?(>|\")/, points: 2, nearTop: true },\n  // using namespace something\n  { pattern: /using( )+namespace( )+.+( )*;/, points: 2 },\n  // template declaration\n  { pattern: /template( )*<.*>/, points: 2 },\n  // std\n  { pattern: /std::\\w+/g, points: 2 },\n  // cout/cin/endl\n  { pattern: /(cout|cin|endl)/g, points: 2 },\n  // Visibility specifiers\n  { pattern: /(public|protected|private):/, points: 2 },\n  // nullptr\n  { pattern: /nullptr/, points: 2 },\n  // new Keyword\n  { pattern: /new \\w+(\\(.*\\))?/, points: 1 },\n  // #define macro\n  { pattern: /#define( )+.+/, points: 1 },\n  // template usage\n  { pattern: /\\w+<\\w+>/, points: 1 },\n  // class keyword\n  { pattern: /class( )+\\w+/, points: 1 },\n  // void keyword\n  { pattern: /void/g, points: 1 },\n  // (else )if statement\n  { pattern: /(else )?if( )*\\(.+\\)/, points: 1 },\n  // while loop\n  { pattern: /while( )+\\(.+\\)/, points: 1 },\n  // Scope operator\n  { pattern: /\\w*::\\w+/, points: 1 },\n  // Single quote multicharacter string\n  { pattern: /'.{2,}'/, points: -1 },\n  // Java List/ArrayList\n  { pattern: /(List<\\w+>|ArrayList<\\w*>( )*\\(.*\\))(( )+[\\w]+|;)/, points: -1 }],\n\n  Python: [\n  // Function definition\n  { pattern: /def( )+\\w+\\(.*\\)( )*:/, points: 2 },\n  // while loop\n  { pattern: /while (.+):/, points: 2 },\n  // from library import something\n  { pattern: /from [\\w\\.]+ import (\\w+|\\*)/, points: 2 },\n  // class keyword\n  { pattern: /class( )*\\w+(\\(( )*\\w+( )*\\))?( )*:/, points: 2 },\n  // if keyword\n  { pattern: /if( )+(.+)( )*:/, points: 2 },\n  // elif keyword\n  { pattern: /elif( )+(.+)( )*:/, points: 2 },\n  // else keyword\n  { pattern: /else:/, points: 2 },\n  // for loop\n  { pattern: /for (\\w+|\\(?\\w+,( )*\\w+\\)?) in (.+):/, points: 2 },\n  // Python variable declaration.\n  { pattern: /\\w+( )*=( )*\\w+(?!;)(\\n|$)/, points: 1 },\n  // import something\n  { pattern: /import ([[^\\.]\\w])+/, points: 1, nearTop: true },\n  // print statement/function\n  { pattern: /print((( )*\\(.+\\))|( )+.+)/, points: 1 },\n  // &&/|| operators\n  { pattern: /(&{2}|\\|{2})/, points: -1 }],\n\n  Java: [\n  // System.out.println() etc.\n  { pattern: /System\\.(in|out)\\.\\w+/, points: 2 },\n  // Class variable declarations\n  { pattern: /(private|protected|public)( )*\\w+( )*\\w+(( )*=( )*[\\w])?/, points: 2 },\n  // Method\n  { pattern: /(private|protected|public)( )*\\w+( )*[\\w]+\\(.+\\)/, points: 2 },\n  // String class\n  { pattern: /(^|\\s)(String)( )+[\\w]+( )*=?/, points: 2 },\n  // List/ArrayList\n  { pattern: /(List<\\w+>|ArrayList<\\w*>( )*\\(.*\\))(( )+[\\w]+|;)/, points: 2 },\n  // class keyword\n  { pattern: /(public( )*)?class( )*\\w+/, points: 2 },\n  // Array declaration.\n  { pattern: /(\\w+)(\\[( )*\\])+( )+\\w+/, points: 2 },\n  // final keyword\n  { pattern: /final( )*\\w+/, points: 2 },\n  // getter & setter\n  { pattern: /\\w+\\.(get|set)\\(.+\\)/, points: 2 },\n  // new Keyword (Java)\n  { pattern: /new [A-Z]\\w*( )*\\(.+\\)/, points: 2 },\n  // C style variable declaration.\n  { pattern: /(^|\\s)(char|long|int|float|double)( )+[\\w]+( )*=?/, points: 1 },\n  // extends/implements keywords\n  { pattern: /(extends|implements)/, points: 2, nearTop: true },\n  // null keyword\n  { pattern: /null/g, points: 1 },\n  // (else )if statement\n  { pattern: /(else )?if( )*\\(.+\\)/, points: 1 },\n  // while loop\n  { pattern: /while( )+\\(.+\\)/, points: 1 },\n  // void keyword\n  { pattern: /void/g, points: 1 },\n  // const\n  { pattern: /const( )*\\w+/, points: -1 },\n  // pointer\n  { pattern: /(\\w+)( )*\\*( )*\\w+/, points: -1 },\n  // Single quote multicharacter string\n  { pattern: /'.{2,}'/, points: -1 },\n  // C style include\n  { pattern: /#include( )*(<|\")\\w+(\\.h)?(>|\")/, points: -1, nearTop: true }],\n\n  HTML: [{ pattern: /<!DOCTYPE (html|HTML PUBLIC .+)>/, points: 2, nearTop: true },\n  // Tags\n  { pattern: /<[a-z0-9]+(( )*[\\w]+=('|\").+('|\")( )*)?>.*<\\/[a-z0-9]+>/g, points: 2 },\n  // Properties\n  { pattern: /[a-z\\-]+=(\"|').+(\"|')/g, points: 2 },\n  // PHP tag\n  { pattern: /<\\?php/, points: -50 }],\n\n  CSS: [\n  // Properties\n  { pattern: /[a-z\\-]+:(?!:).+;/, points: 2 },\n  // <style> tag from HTML\n  { pattern: /<(\\/)?style>/, points: -50 }],\n\n  Ruby: [\n  // require/include\n  { pattern: /(require|include)( )+'\\w+(\\.rb)?'/, points: 2, nearTop: true },\n  // Function definition\n  { pattern: /def( )+\\w+( )*(\\(.+\\))?( )*\\n/, points: 2 },\n  // Instance variables\n  { pattern: /@\\w+/, points: 2 },\n  // Boolean property\n  { pattern: /\\.\\w+\\?/, points: 2 },\n  // puts (Ruby print)\n  { pattern: /puts( )+(\"|').+(\"|')/, points: 2 },\n  // Inheriting class\n  { pattern: /class [A-Z]\\w*( )*<( )*([A-Z]\\w*(::)?)+/, points: 2 },\n  // attr_accessor\n  { pattern: /attr_accessor( )+(:\\w+(,( )*)?)+/, points: 2 },\n  // new\n  { pattern: /\\w+\\.new( )+/, points: 2 },\n  // elsif keyword\n  { pattern: /elsif/, points: 2 },\n  // do\n  { pattern: /do( )*\\|(\\w+(,( )*\\w+)?)+\\|/, points: 2 },\n  // for loop\n  { pattern: /for (\\w+|\\(?\\w+,( )*\\w+\\)?) in (.+)/, points: 1 },\n  // nil keyword\n  { pattern: /nil/, points: 1 },\n  // Scope operator\n  { pattern: /[A-Z]\\w*::[A-Z]\\w*/, points: 1 }],\n\n  Go: [\n  // package something\n  { pattern: /package( )+[a-z]+\\n/, points: 2, nearTop: true },\n  // import\n  { pattern: /(import( )*\\(( )*\\n)|(import( )+\"[a-z0-9\\/\\.]+\")/, points: 2, nearTop: true },\n  // error check\n  { pattern: /if.+err( )*!=( )*nil.+{/, points: 2 },\n  // Go print\n  { pattern: /fmt\\.Print(f|ln)?\\(.*\\)/, points: 2 },\n  // function\n  { pattern: /func(( )+\\w+( )*)?\\(.*\\).*{/, points: 2 },\n  // variable initialisation\n  { pattern: /\\w+( )*:=( )*.+[^;\\n]/, points: 2 },\n  // if/else if\n  { pattern: /(}( )*else( )*)?if[^\\(\\)]+{/, points: 2 },\n  // var/const declaration\n  { pattern: /(var|const)( )+\\w+( )+[\\w\\*]+(\\n|( )*=|$)/, points: 2 },\n  // public access on package\n  { pattern: /[a-z]+\\.[A-Z]\\w*/, points: 1 },\n  // nil keyword\n  { pattern: /nil/, points: 1 },\n  // Single quote multicharacter string\n  { pattern: /'.{2,}'/, points: -1 }],\n\n  PHP: [\n  // PHP tag\n  { pattern: /<\\?php/, points: 2 },\n  // PHP style variables.\n  { pattern: /\\$\\w+/, points: 2 },\n  // use Something\\Something;\n  { pattern: /use( )+\\w+(\\\\\\w+)+( )*;/, points: 2, nearTop: true },\n  // arrow\n  { pattern: /\\$\\w+\\->\\w+/, points: 2 },\n  // require/include\n  { pattern: /(require|include)(_once)?( )*\\(?( )*('|\").+\\.php('|\")( )*\\)?( )*;/, points: 2 },\n  // echo 'something';\n  { pattern: /echo( )+('|\").+('|\")( )*;/, points: 1 },\n  // NULL constant\n  { pattern: /NULL/, points: 1 },\n  // new keyword\n  { pattern: /new( )+((\\\\\\w+)+|\\w+)(\\(.*\\))?/, points: 1 },\n  // Function definition\n  { pattern: /function(( )+[\\$\\w]+\\(.*\\)|( )*\\(.*\\))/g, points: 1 },\n  // (else)if statement\n  { pattern: /(else)?if( )+\\(.+\\)/, points: 1 },\n  // scope operator\n  { pattern: /\\w+::\\w+/, points: 1 },\n  // === operator\n  { pattern: /\\===/g, points: 1 },\n  // !== operator\n  { pattern: /!==/g, points: 1 },\n  // C/JS style variable declaration.\n  { pattern: /(^|\\s)(var|char|long|int|float|double)( )+\\w+( )*=?/, points: -1 }],\n\n  Unknown: []\n};\n\nfunction getPoints(language, lineOfCode, checkers) {\n  return checkers.map(function (checker) {\n    if (checker.pattern.test(lineOfCode)) {\n      return checker.points;\n    }\n    return 0;\n  }).reduce(function (memo, num) { return memo + num; }, 0);\n}\n\nfunction detect(snippet, options) {\n  var opts = Object.assign({\n    heuristic: true,\n    statistics: false\n  }, options || {});\n\n  var linesOfCode = snippet.replace(/\\r\\n?/g, '\\n').replace(/\\n{2,}/g, '\\n').split('\\n');\n\n  function nearTop(index) {\n    if (linesOfCode.length <= 10) {\n      return true;\n    }\n    return index < linesOfCode.length / 10;\n  }\n\n  if (opts.heuristic && linesOfCode.length > 500) {\n    linesOfCode = linesOfCode.filter(function (lineOfCode, index) {\n      if (nearTop(index)) {\n        return true;\n      }\n      return index % Math.ceil(linesOfCode.length / 500) === 0;\n    });\n  }\n\n  var pairs = Object.keys(LANGUAGES).map(function (key) {\n    return { language: key, checkers: LANGUAGES[key] };\n  });\n\n  var results = pairs.map(function (pairs) {\n    var language = pairs.language;\n    var checkers = pairs.checkers;\n\n    if (language === 'Unknown') {\n      return { language: 'Unknown', points: 1 };\n    }\n\n    var pointsList = linesOfCode.map(function (lineOfCode, index) {\n      if (!nearTop(index)) {\n        return getPoints(language, lineOfCode, checkers.filter(function (checker) { return !checker.nearTop; }));\n      }\n      return getPoints(language, lineOfCode, checkers);\n    });\n\n    var points = pointsList.reduce(function (memo, num) { return memo + num; });\n\n    return { language: language, points: points };\n  });\n\n  var sortedResult = results.sort(function (prev, next) { return prev.points - next.points; });\n  var bestResult = sortedResult[sortedResult.length - 1];\n\n  if (opts.statistics) {\n    var statistics = {};\n    results.forEach(function (result) {\n      statistics[result.language] = result.points;\n    });\n    return { detected: bestResult.language, statistics: statistics };\n  }\n\n  return bestResult.language;\n}\n\nvar languages = Object.keys(LANGUAGES);\nvar LANG = {};\n\nlanguages.forEach(function (language) {\n  LANG[language] = language;\n});\n\n\n\n\n//# sourceURL=webpack://froala-syntax-highlighter/./node_modules/program-language-detector/dist/programLanguageDetector.es.js?")},"./node_modules/shiki/dist/index.esm.js":(__unused_webpack_module,__webpack_exports__,__webpack_require__)=>{"use strict";eval("var __dirname = \"/\";\n__webpack_require__.r(__webpack_exports__);\n/* harmony export */ __webpack_require__.d(__webpack_exports__, {\n/* harmony export */   \"BUNDLED_LANGUAGES\": () => (/* binding */ languages),\n/* harmony export */   \"BUNDLED_THEMES\": () => (/* binding */ themes),\n/* harmony export */   \"FontStyle\": () => (/* binding */ FontStyle),\n/* harmony export */   \"getHighlighter\": () => (/* binding */ getHighlighter),\n/* harmony export */   \"loadTheme\": () => (/* binding */ fetchTheme),\n/* harmony export */   \"renderToHtml\": () => (/* binding */ renderToHtml),\n/* harmony export */   \"setCDN\": () => (/* binding */ setCDN),\n/* harmony export */   \"setOnigasmWASM\": () => (/* binding */ setOnigasmWASM),\n/* harmony export */   \"setWasm\": () => (/* binding */ setWasm),\n/* harmony export */   \"toShikiTheme\": () => (/* binding */ toShikiTheme)\n/* harmony export */ });\n/* harmony import */ var vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vscode-oniguruma */ \"./node_modules/vscode-oniguruma/release/main.js\");\n/* harmony import */ var vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var vscode_textmate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! vscode-textmate */ \"./node_modules/vscode-textmate/release/main.js\");\n/* harmony import */ var vscode_textmate__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(vscode_textmate__WEBPACK_IMPORTED_MODULE_1__);\n\n\n\nconst themes = [\r\n    'css-variables',\r\n    'dark-plus',\r\n    'dracula-soft',\r\n    'dracula',\r\n    'github-dark-dimmed',\r\n    'github-dark',\r\n    'github-light',\r\n    'light-plus',\r\n    'material-darker',\r\n    'material-default',\r\n    'material-lighter',\r\n    'material-ocean',\r\n    'material-palenight',\r\n    'min-dark',\r\n    'min-light',\r\n    'monokai',\r\n    'nord',\r\n    'one-dark-pro',\r\n    'poimandres',\r\n    'rose-pine-dawn',\r\n    'rose-pine-moon',\r\n    'rose-pine',\r\n    'slack-dark',\r\n    'slack-ochin',\r\n    'solarized-dark',\r\n    'solarized-light',\r\n    'vitesse-dark',\r\n    'vitesse-light'\r\n];\n\nconst languages = [\r\n    {\r\n        id: 'abap',\r\n        scopeName: 'source.abap',\r\n        path: 'abap.tmLanguage.json',\r\n        samplePath: 'abap.sample'\r\n    },\r\n    {\r\n        id: 'actionscript-3',\r\n        scopeName: 'source.actionscript.3',\r\n        path: 'actionscript-3.tmLanguage.json',\r\n        samplePath: 'actionscript-3.sample'\r\n    },\r\n    {\r\n        id: 'ada',\r\n        scopeName: 'source.ada',\r\n        path: 'ada.tmLanguage.json',\r\n        samplePath: 'ada.sample'\r\n    },\r\n    {\r\n        id: 'apache',\r\n        scopeName: 'source.apacheconf',\r\n        path: 'apache.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'apex',\r\n        scopeName: 'source.apex',\r\n        path: 'apex.tmLanguage.json',\r\n        samplePath: 'apex.sample'\r\n    },\r\n    {\r\n        id: 'apl',\r\n        scopeName: 'source.apl',\r\n        path: 'apl.tmLanguage.json',\r\n        embeddedLangs: ['html', 'xml', 'css', 'javascript', 'json']\r\n    },\r\n    {\r\n        id: 'applescript',\r\n        scopeName: 'source.applescript',\r\n        path: 'applescript.tmLanguage.json',\r\n        samplePath: 'applescript.sample'\r\n    },\r\n    {\r\n        id: 'asm',\r\n        scopeName: 'source.asm.x86_64',\r\n        path: 'asm.tmLanguage.json',\r\n        samplePath: 'asm.sample'\r\n    },\r\n    {\r\n        id: 'astro',\r\n        scopeName: 'text.html.astro',\r\n        path: 'astro.tmLanguage.json',\r\n        samplePath: 'astro.sample',\r\n        embeddedLangs: ['css', 'javascript', 'less', 'sass', 'scss', 'stylus', 'typescript', 'tsx']\r\n    },\r\n    {\r\n        id: 'awk',\r\n        scopeName: 'source.awk',\r\n        path: 'awk.tmLanguage.json',\r\n        samplePath: 'awk.sample'\r\n    },\r\n    {\r\n        id: 'ballerina',\r\n        scopeName: 'source.ballerina',\r\n        path: 'ballerina.tmLanguage.json',\r\n        samplePath: 'ballerina.sample'\r\n    },\r\n    {\r\n        id: 'bat',\r\n        scopeName: 'source.batchfile',\r\n        path: 'bat.tmLanguage.json',\r\n        samplePath: 'bat.sample',\r\n        aliases: ['batch']\r\n    },\r\n    {\r\n        id: 'berry',\r\n        scopeName: 'source.berry',\r\n        path: 'berry.tmLanguage.json',\r\n        samplePath: 'berry.sample',\r\n        aliases: ['be']\r\n    },\r\n    {\r\n        id: 'bibtex',\r\n        scopeName: 'text.bibtex',\r\n        path: 'bibtex.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'bicep',\r\n        scopeName: 'source.bicep',\r\n        path: 'bicep.tmLanguage.json',\r\n        samplePath: 'bicep.sample'\r\n    },\r\n    {\r\n        id: 'c',\r\n        scopeName: 'source.c',\r\n        path: 'c.tmLanguage.json',\r\n        samplePath: 'c.sample'\r\n    },\r\n    {\r\n        id: 'clojure',\r\n        scopeName: 'source.clojure',\r\n        path: 'clojure.tmLanguage.json',\r\n        samplePath: 'clojure.sample',\r\n        aliases: ['clj']\r\n    },\r\n    {\r\n        id: 'cobol',\r\n        scopeName: 'source.cobol',\r\n        path: 'cobol.tmLanguage.json',\r\n        samplePath: 'cobol.sample',\r\n        embeddedLangs: ['sql', 'html', 'java']\r\n    },\r\n    {\r\n        id: 'codeql',\r\n        scopeName: 'source.ql',\r\n        path: 'codeql.tmLanguage.json',\r\n        samplePath: 'codeql.sample',\r\n        aliases: ['ql']\r\n    },\r\n    {\r\n        id: 'coffee',\r\n        scopeName: 'source.coffee',\r\n        path: 'coffee.tmLanguage.json',\r\n        samplePath: 'coffee.sample',\r\n        embeddedLangs: ['javascript']\r\n    },\r\n    {\r\n        id: 'cpp',\r\n        scopeName: 'source.cpp',\r\n        path: 'cpp.tmLanguage.json',\r\n        samplePath: 'cpp.sample',\r\n        embeddedLangs: ['sql']\r\n    },\r\n    {\r\n        id: 'crystal',\r\n        scopeName: 'source.crystal',\r\n        path: 'crystal.tmLanguage.json',\r\n        samplePath: 'crystal.sample',\r\n        embeddedLangs: ['html', 'sql', 'css', 'c', 'javascript', 'shellscript']\r\n    },\r\n    {\r\n        id: 'csharp',\r\n        scopeName: 'source.cs',\r\n        path: 'csharp.tmLanguage.json',\r\n        samplePath: 'csharp.sample',\r\n        aliases: ['c#']\r\n    },\r\n    {\r\n        id: 'css',\r\n        scopeName: 'source.css',\r\n        path: 'css.tmLanguage.json',\r\n        samplePath: 'css.sample'\r\n    },\r\n    {\r\n        id: 'cue',\r\n        scopeName: 'source.cue',\r\n        path: 'cue.tmLanguage.json',\r\n        samplePath: 'cue.sample'\r\n    },\r\n    {\r\n        id: 'd',\r\n        scopeName: 'source.d',\r\n        path: 'd.tmLanguage.json',\r\n        samplePath: 'd.sample'\r\n    },\r\n    {\r\n        id: 'dart',\r\n        scopeName: 'source.dart',\r\n        path: 'dart.tmLanguage.json',\r\n        samplePath: 'dart.sample'\r\n    },\r\n    {\r\n        id: 'diff',\r\n        scopeName: 'source.diff',\r\n        path: 'diff.tmLanguage.json',\r\n        samplePath: 'diff.sample'\r\n    },\r\n    {\r\n        id: 'docker',\r\n        scopeName: 'source.dockerfile',\r\n        path: 'docker.tmLanguage.json',\r\n        samplePath: 'docker.sample'\r\n    },\r\n    {\r\n        id: 'dream-maker',\r\n        scopeName: 'source.dm',\r\n        path: 'dream-maker.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'elixir',\r\n        scopeName: 'source.elixir',\r\n        path: 'elixir.tmLanguage.json',\r\n        samplePath: 'elixir.sample',\r\n        embeddedLangs: ['html']\r\n    },\r\n    {\r\n        id: 'elm',\r\n        scopeName: 'source.elm',\r\n        path: 'elm.tmLanguage.json',\r\n        samplePath: 'elm.sample'\r\n    },\r\n    {\r\n        id: 'erb',\r\n        scopeName: 'text.html.erb',\r\n        path: 'erb.tmLanguage.json',\r\n        samplePath: 'erb.sample',\r\n        embeddedLangs: ['html', 'ruby']\r\n    },\r\n    {\r\n        id: 'erlang',\r\n        scopeName: 'source.erlang',\r\n        path: 'erlang.tmLanguage.json',\r\n        samplePath: 'erlang.sample'\r\n    },\r\n    {\r\n        id: 'fish',\r\n        scopeName: 'source.fish',\r\n        path: 'fish.tmLanguage.json',\r\n        samplePath: 'fish.sample'\r\n    },\r\n    {\r\n        id: 'fsharp',\r\n        scopeName: 'source.fsharp',\r\n        path: 'fsharp.tmLanguage.json',\r\n        samplePath: 'fsharp.sample',\r\n        aliases: ['f#'],\r\n        embeddedLangs: ['markdown']\r\n    },\r\n    {\r\n        id: 'gherkin',\r\n        scopeName: 'text.gherkin.feature',\r\n        path: 'gherkin.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'git-commit',\r\n        scopeName: 'text.git-commit',\r\n        path: 'git-commit.tmLanguage.json',\r\n        embeddedLangs: ['diff']\r\n    },\r\n    {\r\n        id: 'git-rebase',\r\n        scopeName: 'text.git-rebase',\r\n        path: 'git-rebase.tmLanguage.json',\r\n        embeddedLangs: ['shellscript']\r\n    },\r\n    {\r\n        id: 'gnuplot',\r\n        scopeName: 'source.gnuplot',\r\n        path: 'gnuplot.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'go',\r\n        scopeName: 'source.go',\r\n        path: 'go.tmLanguage.json',\r\n        samplePath: 'go.sample'\r\n    },\r\n    {\r\n        id: 'graphql',\r\n        scopeName: 'source.graphql',\r\n        path: 'graphql.tmLanguage.json',\r\n        embeddedLangs: ['javascript', 'typescript', 'jsx', 'tsx']\r\n    },\r\n    {\r\n        id: 'groovy',\r\n        scopeName: 'source.groovy',\r\n        path: 'groovy.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'hack',\r\n        scopeName: 'source.hack',\r\n        path: 'hack.tmLanguage.json',\r\n        embeddedLangs: ['html', 'sql']\r\n    },\r\n    {\r\n        id: 'haml',\r\n        scopeName: 'text.haml',\r\n        path: 'haml.tmLanguage.json',\r\n        embeddedLangs: ['ruby', 'javascript', 'sass', 'coffee', 'markdown', 'css']\r\n    },\r\n    {\r\n        id: 'handlebars',\r\n        scopeName: 'text.html.handlebars',\r\n        path: 'handlebars.tmLanguage.json',\r\n        aliases: ['hbs'],\r\n        embeddedLangs: ['html', 'css', 'javascript', 'yaml']\r\n    },\r\n    {\r\n        id: 'haskell',\r\n        scopeName: 'source.haskell',\r\n        path: 'haskell.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'hcl',\r\n        scopeName: 'source.hcl',\r\n        path: 'hcl.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'hlsl',\r\n        scopeName: 'source.hlsl',\r\n        path: 'hlsl.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'html',\r\n        scopeName: 'text.html.basic',\r\n        path: 'html.tmLanguage.json',\r\n        samplePath: 'html.sample',\r\n        embeddedLangs: ['javascript', 'css']\r\n    },\r\n    {\r\n        id: 'ini',\r\n        scopeName: 'source.ini',\r\n        path: 'ini.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'java',\r\n        scopeName: 'source.java',\r\n        path: 'java.tmLanguage.json',\r\n        samplePath: 'java.sample'\r\n    },\r\n    {\r\n        id: 'javascript',\r\n        scopeName: 'source.js',\r\n        path: 'javascript.tmLanguage.json',\r\n        samplePath: 'javascript.sample',\r\n        aliases: ['js']\r\n    },\r\n    {\r\n        id: 'jinja-html',\r\n        scopeName: 'text.html.jinja',\r\n        path: 'jinja-html.tmLanguage.json',\r\n        embeddedLangs: ['html']\r\n    },\r\n    {\r\n        id: 'json',\r\n        scopeName: 'source.json',\r\n        path: 'json.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'jsonc',\r\n        scopeName: 'source.json.comments',\r\n        path: 'jsonc.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'jsonnet',\r\n        scopeName: 'source.jsonnet',\r\n        path: 'jsonnet.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'jssm',\r\n        scopeName: 'source.jssm',\r\n        path: 'jssm.tmLanguage.json',\r\n        samplePath: 'jssm.sample',\r\n        aliases: ['fsl']\r\n    },\r\n    {\r\n        id: 'jsx',\r\n        scopeName: 'source.js.jsx',\r\n        path: 'jsx.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'julia',\r\n        scopeName: 'source.julia',\r\n        path: 'julia.tmLanguage.json',\r\n        embeddedLangs: ['cpp', 'python', 'javascript', 'r', 'sql']\r\n    },\r\n    {\r\n        id: 'jupyter',\r\n        scopeName: 'source.jupyter',\r\n        path: 'jupyter.tmLanguage.json',\r\n        embeddedLangs: ['json']\r\n    },\r\n    {\r\n        id: 'kotlin',\r\n        scopeName: 'source.kotlin',\r\n        path: 'kotlin.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'latex',\r\n        scopeName: 'text.tex.latex',\r\n        path: 'latex.tmLanguage.json',\r\n        embeddedLangs: ['tex', 'css', 'html', 'java', 'javascript', 'typescript', 'lua', 'python', 'julia', 'ruby', 'xml', 'yaml', 'cpp', 'haskell', 'scala', 'gnuplot']\r\n    },\r\n    {\r\n        id: 'less',\r\n        scopeName: 'source.css.less',\r\n        path: 'less.tmLanguage.json',\r\n        embeddedLangs: ['css']\r\n    },\r\n    {\r\n        id: 'lisp',\r\n        scopeName: 'source.lisp',\r\n        path: 'lisp.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'logo',\r\n        scopeName: 'source.logo',\r\n        path: 'logo.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'lua',\r\n        scopeName: 'source.lua',\r\n        path: 'lua.tmLanguage.json',\r\n        embeddedLangs: ['c']\r\n    },\r\n    {\r\n        id: 'make',\r\n        scopeName: 'source.makefile',\r\n        path: 'make.tmLanguage.json',\r\n        aliases: ['makefile']\r\n    },\r\n    {\r\n        id: 'markdown',\r\n        scopeName: 'text.html.markdown',\r\n        path: 'markdown.tmLanguage.json',\r\n        aliases: ['md'],\r\n        embeddedLangs: ['css', 'html', 'ini', 'java', 'lua', 'make', 'perl', 'r', 'ruby', 'php', 'sql', 'vb', 'xml', 'xsl', 'yaml', 'bat', 'clojure', 'coffee', 'c', 'cpp', 'diff', 'docker', 'git-commit', 'git-rebase', 'go', 'groovy', 'pug', 'javascript', 'json', 'jsonc', 'less', 'objective-c', 'swift', 'scss', 'raku', 'powershell', 'python', 'rust', 'scala', 'shellscript', 'typescript', 'tsx', 'csharp', 'fsharp', 'dart', 'handlebars', 'erlang', 'elixir', 'latex', 'bibtex']\r\n    },\r\n    {\r\n        id: 'marko',\r\n        scopeName: 'text.marko',\r\n        path: 'marko.tmLanguage.json',\r\n        samplePath: 'marko.sample',\r\n        embeddedLangs: ['css', 'less', 'scss', 'javascript']\r\n    },\r\n    {\r\n        id: 'matlab',\r\n        scopeName: 'source.matlab',\r\n        path: 'matlab.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'mdx',\r\n        scopeName: 'text.html.markdown.jsx',\r\n        path: 'mdx.tmLanguage.json',\r\n        embeddedLangs: ['jsx', 'markdown']\r\n    },\r\n    {\r\n        id: 'nginx',\r\n        scopeName: 'source.nginx',\r\n        path: 'nginx.tmLanguage.json',\r\n        embeddedLangs: ['lua']\r\n    },\r\n    {\r\n        id: 'nim',\r\n        scopeName: 'source.nim',\r\n        path: 'nim.tmLanguage.json',\r\n        embeddedLangs: ['c', 'html', 'xml', 'javascript', 'css', 'markdown']\r\n    },\r\n    {\r\n        id: 'nix',\r\n        scopeName: 'source.nix',\r\n        path: 'nix.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'objective-c',\r\n        scopeName: 'source.objc',\r\n        path: 'objective-c.tmLanguage.json',\r\n        aliases: ['objc']\r\n    },\r\n    {\r\n        id: 'objective-cpp',\r\n        scopeName: 'source.objcpp',\r\n        path: 'objective-cpp.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'ocaml',\r\n        scopeName: 'source.ocaml',\r\n        path: 'ocaml.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'pascal',\r\n        scopeName: 'source.pascal',\r\n        path: 'pascal.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'perl',\r\n        scopeName: 'source.perl',\r\n        path: 'perl.tmLanguage.json',\r\n        embeddedLangs: ['html', 'xml', 'css', 'javascript', 'sql']\r\n    },\r\n    {\r\n        id: 'php',\r\n        scopeName: 'source.php',\r\n        path: 'php.tmLanguage.json',\r\n        embeddedLangs: ['html', 'xml', 'sql', 'javascript', 'json', 'css']\r\n    },\r\n    {\r\n        id: 'plsql',\r\n        scopeName: 'source.plsql.oracle',\r\n        path: 'plsql.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'postcss',\r\n        scopeName: 'source.css.postcss',\r\n        path: 'postcss.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'powershell',\r\n        scopeName: 'source.powershell',\r\n        path: 'powershell.tmLanguage.json',\r\n        aliases: ['ps', 'ps1']\r\n    },\r\n    {\r\n        id: 'prisma',\r\n        scopeName: 'source.prisma',\r\n        path: 'prisma.tmLanguage.json',\r\n        samplePath: 'prisma.sample'\r\n    },\r\n    {\r\n        id: 'prolog',\r\n        scopeName: 'source.prolog',\r\n        path: 'prolog.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'pug',\r\n        scopeName: 'text.pug',\r\n        path: 'pug.tmLanguage.json',\r\n        aliases: ['jade'],\r\n        embeddedLangs: ['javascript', 'css', 'sass', 'stylus', 'coffee', 'html']\r\n    },\r\n    {\r\n        id: 'puppet',\r\n        scopeName: 'source.puppet',\r\n        path: 'puppet.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'purescript',\r\n        scopeName: 'source.purescript',\r\n        path: 'purescript.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'python',\r\n        scopeName: 'source.python',\r\n        path: 'python.tmLanguage.json',\r\n        samplePath: 'python.sample',\r\n        aliases: ['py']\r\n    },\r\n    {\r\n        id: 'r',\r\n        scopeName: 'source.r',\r\n        path: 'r.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'raku',\r\n        scopeName: 'source.perl.6',\r\n        path: 'raku.tmLanguage.json',\r\n        aliases: ['perl6']\r\n    },\r\n    {\r\n        id: 'razor',\r\n        scopeName: 'text.aspnetcorerazor',\r\n        path: 'razor.tmLanguage.json',\r\n        embeddedLangs: ['html', 'csharp']\r\n    },\r\n    {\r\n        id: 'rel',\r\n        scopeName: 'source.rel',\r\n        path: 'rel.tmLanguage.json',\r\n        samplePath: 'rel.sample'\r\n    },\r\n    {\r\n        id: 'riscv',\r\n        scopeName: 'source.riscv',\r\n        path: 'riscv.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'ruby',\r\n        scopeName: 'source.ruby',\r\n        path: 'ruby.tmLanguage.json',\r\n        samplePath: 'ruby.sample',\r\n        aliases: ['rb'],\r\n        embeddedLangs: ['html', 'xml', 'sql', 'css', 'c', 'javascript', 'shellscript', 'lua']\r\n    },\r\n    {\r\n        id: 'rust',\r\n        scopeName: 'source.rust',\r\n        path: 'rust.tmLanguage.json',\r\n        aliases: ['rs']\r\n    },\r\n    {\r\n        id: 'sas',\r\n        scopeName: 'source.sas',\r\n        path: 'sas.tmLanguage.json',\r\n        embeddedLangs: ['sql']\r\n    },\r\n    {\r\n        id: 'sass',\r\n        scopeName: 'source.sass',\r\n        path: 'sass.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'scala',\r\n        scopeName: 'source.scala',\r\n        path: 'scala.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'scheme',\r\n        scopeName: 'source.scheme',\r\n        path: 'scheme.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'scss',\r\n        scopeName: 'source.css.scss',\r\n        path: 'scss.tmLanguage.json',\r\n        embeddedLangs: ['css']\r\n    },\r\n    {\r\n        id: 'shaderlab',\r\n        scopeName: 'source.shaderlab',\r\n        path: 'shaderlab.tmLanguage.json',\r\n        aliases: ['shader'],\r\n        embeddedLangs: ['hlsl']\r\n    },\r\n    {\r\n        id: 'shellscript',\r\n        scopeName: 'source.shell',\r\n        path: 'shellscript.tmLanguage.json',\r\n        aliases: ['shell', 'bash', 'sh', 'zsh'],\r\n        embeddedLangs: ['ruby', 'python', 'applescript', 'html', 'markdown']\r\n    },\r\n    {\r\n        id: 'smalltalk',\r\n        scopeName: 'source.smalltalk',\r\n        path: 'smalltalk.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'solidity',\r\n        scopeName: 'source.solidity',\r\n        path: 'solidity.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'sparql',\r\n        scopeName: 'source.sparql',\r\n        path: 'sparql.tmLanguage.json',\r\n        samplePath: 'sparql.sample',\r\n        embeddedLangs: ['turtle']\r\n    },\r\n    {\r\n        id: 'sql',\r\n        scopeName: 'source.sql',\r\n        path: 'sql.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'ssh-config',\r\n        scopeName: 'source.ssh-config',\r\n        path: 'ssh-config.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'stata',\r\n        scopeName: 'source.stata',\r\n        path: 'stata.tmLanguage.json',\r\n        samplePath: 'stata.sample',\r\n        embeddedLangs: ['sql']\r\n    },\r\n    {\r\n        id: 'stylus',\r\n        scopeName: 'source.stylus',\r\n        path: 'stylus.tmLanguage.json',\r\n        aliases: ['styl']\r\n    },\r\n    {\r\n        id: 'svelte',\r\n        scopeName: 'source.svelte',\r\n        path: 'svelte.tmLanguage.json',\r\n        embeddedLangs: ['javascript', 'typescript', 'coffee', 'stylus', 'sass', 'css', 'scss', 'less', 'postcss', 'pug', 'markdown']\r\n    },\r\n    {\r\n        id: 'swift',\r\n        scopeName: 'source.swift',\r\n        path: 'swift.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'system-verilog',\r\n        scopeName: 'source.systemverilog',\r\n        path: 'system-verilog.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'tasl',\r\n        scopeName: 'source.tasl',\r\n        path: 'tasl.tmLanguage.json',\r\n        samplePath: 'tasl.sample'\r\n    },\r\n    {\r\n        id: 'tcl',\r\n        scopeName: 'source.tcl',\r\n        path: 'tcl.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'tex',\r\n        scopeName: 'text.tex',\r\n        path: 'tex.tmLanguage.json',\r\n        embeddedLangs: ['r']\r\n    },\r\n    {\r\n        id: 'toml',\r\n        scopeName: 'source.toml',\r\n        path: 'toml.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'tsx',\r\n        scopeName: 'source.tsx',\r\n        path: 'tsx.tmLanguage.json',\r\n        samplePath: 'tsx.sample'\r\n    },\r\n    {\r\n        id: 'turtle',\r\n        scopeName: 'source.turtle',\r\n        path: 'turtle.tmLanguage.json',\r\n        samplePath: 'turtle.sample'\r\n    },\r\n    {\r\n        id: 'twig',\r\n        scopeName: 'text.html.twig',\r\n        path: 'twig.tmLanguage.json',\r\n        embeddedLangs: ['css', 'javascript', 'php', 'python', 'ruby']\r\n    },\r\n    {\r\n        id: 'typescript',\r\n        scopeName: 'source.ts',\r\n        path: 'typescript.tmLanguage.json',\r\n        aliases: ['ts']\r\n    },\r\n    {\r\n        id: 'vb',\r\n        scopeName: 'source.asp.vb.net',\r\n        path: 'vb.tmLanguage.json',\r\n        aliases: ['cmd']\r\n    },\r\n    {\r\n        id: 'verilog',\r\n        scopeName: 'source.verilog',\r\n        path: 'verilog.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'vhdl',\r\n        scopeName: 'source.vhdl',\r\n        path: 'vhdl.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'viml',\r\n        scopeName: 'source.viml',\r\n        path: 'viml.tmLanguage.json',\r\n        aliases: ['vim', 'vimscript']\r\n    },\r\n    {\r\n        id: 'vue-html',\r\n        scopeName: 'text.html.vue-html',\r\n        path: 'vue-html.tmLanguage.json',\r\n        embeddedLangs: ['vue', 'javascript']\r\n    },\r\n    {\r\n        id: 'vue',\r\n        scopeName: 'source.vue',\r\n        path: 'vue.tmLanguage.json',\r\n        embeddedLangs: ['json', 'markdown', 'pug', 'haml', 'vue-html', 'sass', 'scss', 'less', 'stylus', 'postcss', 'css', 'typescript', 'coffee', 'javascript']\r\n    },\r\n    {\r\n        id: 'wasm',\r\n        scopeName: 'source.wat',\r\n        path: 'wasm.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'wenyan',\r\n        scopeName: 'source.wenyan',\r\n        path: 'wenyan.tmLanguage.json',\r\n        aliases: ['文言']\r\n    },\r\n    {\r\n        id: 'xml',\r\n        scopeName: 'text.xml',\r\n        path: 'xml.tmLanguage.json',\r\n        embeddedLangs: ['java']\r\n    },\r\n    {\r\n        id: 'xsl',\r\n        scopeName: 'text.xml.xsl',\r\n        path: 'xsl.tmLanguage.json',\r\n        embeddedLangs: ['xml']\r\n    },\r\n    {\r\n        id: 'yaml',\r\n        scopeName: 'source.yaml',\r\n        path: 'yaml.tmLanguage.json'\r\n    },\r\n    {\r\n        id: 'zenscript',\r\n        scopeName: 'source.zenscript',\r\n        path: 'zenscript.tmLanguage.json',\r\n        samplePath: 'zenscript.sample'\r\n    }\r\n];\n\nvar FontStyle;\r\n(function (FontStyle) {\r\n    FontStyle[FontStyle[\"NotSet\"] = -1] = \"NotSet\";\r\n    FontStyle[FontStyle[\"None\"] = 0] = \"None\";\r\n    FontStyle[FontStyle[\"Italic\"] = 1] = \"Italic\";\r\n    FontStyle[FontStyle[\"Bold\"] = 2] = \"Bold\";\r\n    FontStyle[FontStyle[\"Underline\"] = 4] = \"Underline\";\r\n})(FontStyle || (FontStyle = {}));\r\nclass StackElementMetadata {\r\n    static toBinaryStr(metadata) {\r\n        let r = metadata.toString(2);\r\n        while (r.length < 32) {\r\n            r = '0' + r;\r\n        }\r\n        return r;\r\n    }\r\n    static printMetadata(metadata) {\r\n        let languageId = StackElementMetadata.getLanguageId(metadata);\r\n        let tokenType = StackElementMetadata.getTokenType(metadata);\r\n        let fontStyle = StackElementMetadata.getFontStyle(metadata);\r\n        let foreground = StackElementMetadata.getForeground(metadata);\r\n        let background = StackElementMetadata.getBackground(metadata);\r\n        console.log({\r\n            languageId: languageId,\r\n            tokenType: tokenType,\r\n            fontStyle: fontStyle,\r\n            foreground: foreground,\r\n            background: background\r\n        });\r\n    }\r\n    static getLanguageId(metadata) {\r\n        return (metadata & 255 /* LANGUAGEID_MASK */) >>> 0 /* LANGUAGEID_OFFSET */;\r\n    }\r\n    static getTokenType(metadata) {\r\n        return (metadata & 1792 /* TOKEN_TYPE_MASK */) >>> 8 /* TOKEN_TYPE_OFFSET */;\r\n    }\r\n    static getFontStyle(metadata) {\r\n        return (metadata & 14336 /* FONT_STYLE_MASK */) >>> 11 /* FONT_STYLE_OFFSET */;\r\n    }\r\n    static getForeground(metadata) {\r\n        return (metadata & 8372224 /* FOREGROUND_MASK */) >>> 14 /* FOREGROUND_OFFSET */;\r\n    }\r\n    static getBackground(metadata) {\r\n        return (metadata & 4286578688 /* BACKGROUND_MASK */) >>> 23 /* BACKGROUND_OFFSET */;\r\n    }\r\n    static set(metadata, languageId, tokenType, fontStyle, foreground, background) {\r\n        let _languageId = StackElementMetadata.getLanguageId(metadata);\r\n        let _tokenType = StackElementMetadata.getTokenType(metadata);\r\n        let _fontStyle = StackElementMetadata.getFontStyle(metadata);\r\n        let _foreground = StackElementMetadata.getForeground(metadata);\r\n        let _background = StackElementMetadata.getBackground(metadata);\r\n        if (languageId !== 0) {\r\n            _languageId = languageId;\r\n        }\r\n        if (tokenType !== 0 /* Other */) {\r\n            _tokenType =\r\n                tokenType === 8 /* MetaEmbedded */ ? 0 /* Other */ : tokenType;\r\n        }\r\n        if (fontStyle !== FontStyle.NotSet) {\r\n            _fontStyle = fontStyle;\r\n        }\r\n        if (foreground !== 0) {\r\n            _foreground = foreground;\r\n        }\r\n        if (background !== 0) {\r\n            _background = background;\r\n        }\r\n        return (((_languageId << 0 /* LANGUAGEID_OFFSET */) |\r\n            (_tokenType << 8 /* TOKEN_TYPE_OFFSET */) |\r\n            (_fontStyle << 11 /* FONT_STYLE_OFFSET */) |\r\n            (_foreground << 14 /* FOREGROUND_OFFSET */) |\r\n            (_background << 23 /* BACKGROUND_OFFSET */)) >>>\r\n            0);\r\n    }\r\n}\n\nfunction trimEndSlash(str) {\r\n    if (str.endsWith('/') || str.endsWith('\\\\'))\r\n        return str.slice(0, -1);\r\n    return str;\r\n}\r\nfunction trimStartDot(str) {\r\n    if (str.startsWith('./'))\r\n        return str.slice(2);\r\n    return str;\r\n}\r\nfunction dirname(str) {\r\n    const parts = str.split(/[\\/\\\\]/g);\r\n    return parts[parts.length - 2];\r\n}\r\nfunction join(...parts) {\r\n    return parts.map(trimEndSlash).map(trimStartDot).join('/');\r\n}\r\nfunction groupBy(elements, keyGetter) {\r\n    const map = new Map();\r\n    for (const element of elements) {\r\n        const key = keyGetter(element);\r\n        if (map.has(key)) {\r\n            const group = map.get(key);\r\n            group.push(element);\r\n        }\r\n        else {\r\n            map.set(key, [element]);\r\n        }\r\n    }\r\n    return map;\r\n}\n\n/*---------------------------------------------------------------------------------------------\n *  Copyright (c) Microsoft Corporation. All rights reserved.\n *  Licensed under the MIT License. See License.txt in the project root for license information.\n *--------------------------------------------------------------------------------------------*/\n/**\n * Creates a JSON scanner on the given text.\n * If ignoreTrivia is set, whitespaces or comments are ignored.\n */\nfunction createScanner(text, ignoreTrivia) {\n    if (ignoreTrivia === void 0) { ignoreTrivia = false; }\n    var len = text.length;\n    var pos = 0, value = '', tokenOffset = 0, token = 16 /* Unknown */, lineNumber = 0, lineStartOffset = 0, tokenLineStartOffset = 0, prevTokenLineStartOffset = 0, scanError = 0 /* None */;\n    function scanHexDigits(count, exact) {\n        var digits = 0;\n        var value = 0;\n        while (digits < count || !exact) {\n            var ch = text.charCodeAt(pos);\n            if (ch >= 48 /* _0 */ && ch <= 57 /* _9 */) {\n                value = value * 16 + ch - 48 /* _0 */;\n            }\n            else if (ch >= 65 /* A */ && ch <= 70 /* F */) {\n                value = value * 16 + ch - 65 /* A */ + 10;\n            }\n            else if (ch >= 97 /* a */ && ch <= 102 /* f */) {\n                value = value * 16 + ch - 97 /* a */ + 10;\n            }\n            else {\n                break;\n            }\n            pos++;\n            digits++;\n        }\n        if (digits < count) {\n            value = -1;\n        }\n        return value;\n    }\n    function setPosition(newPosition) {\n        pos = newPosition;\n        value = '';\n        tokenOffset = 0;\n        token = 16 /* Unknown */;\n        scanError = 0 /* None */;\n    }\n    function scanNumber() {\n        var start = pos;\n        if (text.charCodeAt(pos) === 48 /* _0 */) {\n            pos++;\n        }\n        else {\n            pos++;\n            while (pos < text.length && isDigit(text.charCodeAt(pos))) {\n                pos++;\n            }\n        }\n        if (pos < text.length && text.charCodeAt(pos) === 46 /* dot */) {\n            pos++;\n            if (pos < text.length && isDigit(text.charCodeAt(pos))) {\n                pos++;\n                while (pos < text.length && isDigit(text.charCodeAt(pos))) {\n                    pos++;\n                }\n            }\n            else {\n                scanError = 3 /* UnexpectedEndOfNumber */;\n                return text.substring(start, pos);\n            }\n        }\n        var end = pos;\n        if (pos < text.length && (text.charCodeAt(pos) === 69 /* E */ || text.charCodeAt(pos) === 101 /* e */)) {\n            pos++;\n            if (pos < text.length && text.charCodeAt(pos) === 43 /* plus */ || text.charCodeAt(pos) === 45 /* minus */) {\n                pos++;\n            }\n            if (pos < text.length && isDigit(text.charCodeAt(pos))) {\n                pos++;\n                while (pos < text.length && isDigit(text.charCodeAt(pos))) {\n                    pos++;\n                }\n                end = pos;\n            }\n            else {\n                scanError = 3 /* UnexpectedEndOfNumber */;\n            }\n        }\n        return text.substring(start, end);\n    }\n    function scanString() {\n        var result = '', start = pos;\n        while (true) {\n            if (pos >= len) {\n                result += text.substring(start, pos);\n                scanError = 2 /* UnexpectedEndOfString */;\n                break;\n            }\n            var ch = text.charCodeAt(pos);\n            if (ch === 34 /* doubleQuote */) {\n                result += text.substring(start, pos);\n                pos++;\n                break;\n            }\n            if (ch === 92 /* backslash */) {\n                result += text.substring(start, pos);\n                pos++;\n                if (pos >= len) {\n                    scanError = 2 /* UnexpectedEndOfString */;\n                    break;\n                }\n                var ch2 = text.charCodeAt(pos++);\n                switch (ch2) {\n                    case 34 /* doubleQuote */:\n                        result += '\\\"';\n                        break;\n                    case 92 /* backslash */:\n                        result += '\\\\';\n                        break;\n                    case 47 /* slash */:\n                        result += '/';\n                        break;\n                    case 98 /* b */:\n                        result += '\\b';\n                        break;\n                    case 102 /* f */:\n                        result += '\\f';\n                        break;\n                    case 110 /* n */:\n                        result += '\\n';\n                        break;\n                    case 114 /* r */:\n                        result += '\\r';\n                        break;\n                    case 116 /* t */:\n                        result += '\\t';\n                        break;\n                    case 117 /* u */:\n                        var ch3 = scanHexDigits(4, true);\n                        if (ch3 >= 0) {\n                            result += String.fromCharCode(ch3);\n                        }\n                        else {\n                            scanError = 4 /* InvalidUnicode */;\n                        }\n                        break;\n                    default:\n                        scanError = 5 /* InvalidEscapeCharacter */;\n                }\n                start = pos;\n                continue;\n            }\n            if (ch >= 0 && ch <= 0x1f) {\n                if (isLineBreak(ch)) {\n                    result += text.substring(start, pos);\n                    scanError = 2 /* UnexpectedEndOfString */;\n                    break;\n                }\n                else {\n                    scanError = 6 /* InvalidCharacter */;\n                    // mark as error but continue with string\n                }\n            }\n            pos++;\n        }\n        return result;\n    }\n    function scanNext() {\n        value = '';\n        scanError = 0 /* None */;\n        tokenOffset = pos;\n        lineStartOffset = lineNumber;\n        prevTokenLineStartOffset = tokenLineStartOffset;\n        if (pos >= len) {\n            // at the end\n            tokenOffset = len;\n            return token = 17 /* EOF */;\n        }\n        var code = text.charCodeAt(pos);\n        // trivia: whitespace\n        if (isWhiteSpace(code)) {\n            do {\n                pos++;\n                value += String.fromCharCode(code);\n                code = text.charCodeAt(pos);\n            } while (isWhiteSpace(code));\n            return token = 15 /* Trivia */;\n        }\n        // trivia: newlines\n        if (isLineBreak(code)) {\n            pos++;\n            value += String.fromCharCode(code);\n            if (code === 13 /* carriageReturn */ && text.charCodeAt(pos) === 10 /* lineFeed */) {\n                pos++;\n                value += '\\n';\n            }\n            lineNumber++;\n            tokenLineStartOffset = pos;\n            return token = 14 /* LineBreakTrivia */;\n        }\n        switch (code) {\n            // tokens: []{}:,\n            case 123 /* openBrace */:\n                pos++;\n                return token = 1 /* OpenBraceToken */;\n            case 125 /* closeBrace */:\n                pos++;\n                return token = 2 /* CloseBraceToken */;\n            case 91 /* openBracket */:\n                pos++;\n                return token = 3 /* OpenBracketToken */;\n            case 93 /* closeBracket */:\n                pos++;\n                return token = 4 /* CloseBracketToken */;\n            case 58 /* colon */:\n                pos++;\n                return token = 6 /* ColonToken */;\n            case 44 /* comma */:\n                pos++;\n                return token = 5 /* CommaToken */;\n            // strings\n            case 34 /* doubleQuote */:\n                pos++;\n                value = scanString();\n                return token = 10 /* StringLiteral */;\n            // comments\n            case 47 /* slash */:\n                var start = pos - 1;\n                // Single-line comment\n                if (text.charCodeAt(pos + 1) === 47 /* slash */) {\n                    pos += 2;\n                    while (pos < len) {\n                        if (isLineBreak(text.charCodeAt(pos))) {\n                            break;\n                        }\n                        pos++;\n                    }\n                    value = text.substring(start, pos);\n                    return token = 12 /* LineCommentTrivia */;\n                }\n                // Multi-line comment\n                if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {\n                    pos += 2;\n                    var safeLength = len - 1; // For lookahead.\n                    var commentClosed = false;\n                    while (pos < safeLength) {\n                        var ch = text.charCodeAt(pos);\n                        if (ch === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {\n                            pos += 2;\n                            commentClosed = true;\n                            break;\n                        }\n                        pos++;\n                        if (isLineBreak(ch)) {\n                            if (ch === 13 /* carriageReturn */ && text.charCodeAt(pos) === 10 /* lineFeed */) {\n                                pos++;\n                            }\n                            lineNumber++;\n                            tokenLineStartOffset = pos;\n                        }\n                    }\n                    if (!commentClosed) {\n                        pos++;\n                        scanError = 1 /* UnexpectedEndOfComment */;\n                    }\n                    value = text.substring(start, pos);\n                    return token = 13 /* BlockCommentTrivia */;\n                }\n                // just a single slash\n                value += String.fromCharCode(code);\n                pos++;\n                return token = 16 /* Unknown */;\n            // numbers\n            case 45 /* minus */:\n                value += String.fromCharCode(code);\n                pos++;\n                if (pos === len || !isDigit(text.charCodeAt(pos))) {\n                    return token = 16 /* Unknown */;\n                }\n            // found a minus, followed by a number so\n            // we fall through to proceed with scanning\n            // numbers\n            case 48 /* _0 */:\n            case 49 /* _1 */:\n            case 50 /* _2 */:\n            case 51 /* _3 */:\n            case 52 /* _4 */:\n            case 53 /* _5 */:\n            case 54 /* _6 */:\n            case 55 /* _7 */:\n            case 56 /* _8 */:\n            case 57 /* _9 */:\n                value += scanNumber();\n                return token = 11 /* NumericLiteral */;\n            // literals and unknown symbols\n            default:\n                // is a literal? Read the full word.\n                while (pos < len && isUnknownContentCharacter(code)) {\n                    pos++;\n                    code = text.charCodeAt(pos);\n                }\n                if (tokenOffset !== pos) {\n                    value = text.substring(tokenOffset, pos);\n                    // keywords: true, false, null\n                    switch (value) {\n                        case 'true': return token = 8 /* TrueKeyword */;\n                        case 'false': return token = 9 /* FalseKeyword */;\n                        case 'null': return token = 7 /* NullKeyword */;\n                    }\n                    return token = 16 /* Unknown */;\n                }\n                // some\n                value += String.fromCharCode(code);\n                pos++;\n                return token = 16 /* Unknown */;\n        }\n    }\n    function isUnknownContentCharacter(code) {\n        if (isWhiteSpace(code) || isLineBreak(code)) {\n            return false;\n        }\n        switch (code) {\n            case 125 /* closeBrace */:\n            case 93 /* closeBracket */:\n            case 123 /* openBrace */:\n            case 91 /* openBracket */:\n            case 34 /* doubleQuote */:\n            case 58 /* colon */:\n            case 44 /* comma */:\n            case 47 /* slash */:\n                return false;\n        }\n        return true;\n    }\n    function scanNextNonTrivia() {\n        var result;\n        do {\n            result = scanNext();\n        } while (result >= 12 /* LineCommentTrivia */ && result <= 15 /* Trivia */);\n        return result;\n    }\n    return {\n        setPosition: setPosition,\n        getPosition: function () { return pos; },\n        scan: ignoreTrivia ? scanNextNonTrivia : scanNext,\n        getToken: function () { return token; },\n        getTokenValue: function () { return value; },\n        getTokenOffset: function () { return tokenOffset; },\n        getTokenLength: function () { return pos - tokenOffset; },\n        getTokenStartLine: function () { return lineStartOffset; },\n        getTokenStartCharacter: function () { return tokenOffset - prevTokenLineStartOffset; },\n        getTokenError: function () { return scanError; },\n    };\n}\nfunction isWhiteSpace(ch) {\n    return ch === 32 /* space */ || ch === 9 /* tab */ || ch === 11 /* verticalTab */ || ch === 12 /* formFeed */ ||\n        ch === 160 /* nonBreakingSpace */ || ch === 5760 /* ogham */ || ch >= 8192 /* enQuad */ && ch <= 8203 /* zeroWidthSpace */ ||\n        ch === 8239 /* narrowNoBreakSpace */ || ch === 8287 /* mathematicalSpace */ || ch === 12288 /* ideographicSpace */ || ch === 65279 /* byteOrderMark */;\n}\nfunction isLineBreak(ch) {\n    return ch === 10 /* lineFeed */ || ch === 13 /* carriageReturn */ || ch === 8232 /* lineSeparator */ || ch === 8233 /* paragraphSeparator */;\n}\nfunction isDigit(ch) {\n    return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;\n}\n\n/*---------------------------------------------------------------------------------------------\n *  Copyright (c) Microsoft Corporation. All rights reserved.\n *  Licensed under the MIT License. See License.txt in the project root for license information.\n *--------------------------------------------------------------------------------------------*/\nvar ParseOptions;\n(function (ParseOptions) {\n    ParseOptions.DEFAULT = {\n        allowTrailingComma: false\n    };\n})(ParseOptions || (ParseOptions = {}));\n/**\n * Parses the given text and returns the object the JSON content represents. On invalid input, the parser tries to be as fault tolerant as possible, but still return a result.\n * Therefore always check the errors list to find out if the input was valid.\n */\nfunction parse$1(text, errors, options) {\n    if (errors === void 0) { errors = []; }\n    if (options === void 0) { options = ParseOptions.DEFAULT; }\n    var currentProperty = null;\n    var currentParent = [];\n    var previousParents = [];\n    function onValue(value) {\n        if (Array.isArray(currentParent)) {\n            currentParent.push(value);\n        }\n        else if (currentProperty !== null) {\n            currentParent[currentProperty] = value;\n        }\n    }\n    var visitor = {\n        onObjectBegin: function () {\n            var object = {};\n            onValue(object);\n            previousParents.push(currentParent);\n            currentParent = object;\n            currentProperty = null;\n        },\n        onObjectProperty: function (name) {\n            currentProperty = name;\n        },\n        onObjectEnd: function () {\n            currentParent = previousParents.pop();\n        },\n        onArrayBegin: function () {\n            var array = [];\n            onValue(array);\n            previousParents.push(currentParent);\n            currentParent = array;\n            currentProperty = null;\n        },\n        onArrayEnd: function () {\n            currentParent = previousParents.pop();\n        },\n        onLiteralValue: onValue,\n        onError: function (error, offset, length) {\n            errors.push({ error: error, offset: offset, length: length });\n        }\n    };\n    visit(text, visitor, options);\n    return currentParent[0];\n}\n/**\n * Parses the given text and invokes the visitor functions for each object, array and literal reached.\n */\nfunction visit(text, visitor, options) {\n    if (options === void 0) { options = ParseOptions.DEFAULT; }\n    var _scanner = createScanner(text, false);\n    function toNoArgVisit(visitFunction) {\n        return visitFunction ? function () { return visitFunction(_scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter()); } : function () { return true; };\n    }\n    function toOneArgVisit(visitFunction) {\n        return visitFunction ? function (arg) { return visitFunction(arg, _scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter()); } : function () { return true; };\n    }\n    var onObjectBegin = toNoArgVisit(visitor.onObjectBegin), onObjectProperty = toOneArgVisit(visitor.onObjectProperty), onObjectEnd = toNoArgVisit(visitor.onObjectEnd), onArrayBegin = toNoArgVisit(visitor.onArrayBegin), onArrayEnd = toNoArgVisit(visitor.onArrayEnd), onLiteralValue = toOneArgVisit(visitor.onLiteralValue), onSeparator = toOneArgVisit(visitor.onSeparator), onComment = toNoArgVisit(visitor.onComment), onError = toOneArgVisit(visitor.onError);\n    var disallowComments = options && options.disallowComments;\n    var allowTrailingComma = options && options.allowTrailingComma;\n    function scanNext() {\n        while (true) {\n            var token = _scanner.scan();\n            switch (_scanner.getTokenError()) {\n                case 4 /* InvalidUnicode */:\n                    handleError(14 /* InvalidUnicode */);\n                    break;\n                case 5 /* InvalidEscapeCharacter */:\n                    handleError(15 /* InvalidEscapeCharacter */);\n                    break;\n                case 3 /* UnexpectedEndOfNumber */:\n                    handleError(13 /* UnexpectedEndOfNumber */);\n                    break;\n                case 1 /* UnexpectedEndOfComment */:\n                    if (!disallowComments) {\n                        handleError(11 /* UnexpectedEndOfComment */);\n                    }\n                    break;\n                case 2 /* UnexpectedEndOfString */:\n                    handleError(12 /* UnexpectedEndOfString */);\n                    break;\n                case 6 /* InvalidCharacter */:\n                    handleError(16 /* InvalidCharacter */);\n                    break;\n            }\n            switch (token) {\n                case 12 /* LineCommentTrivia */:\n                case 13 /* BlockCommentTrivia */:\n                    if (disallowComments) {\n                        handleError(10 /* InvalidCommentToken */);\n                    }\n                    else {\n                        onComment();\n                    }\n                    break;\n                case 16 /* Unknown */:\n                    handleError(1 /* InvalidSymbol */);\n                    break;\n                case 15 /* Trivia */:\n                case 14 /* LineBreakTrivia */:\n                    break;\n                default:\n                    return token;\n            }\n        }\n    }\n    function handleError(error, skipUntilAfter, skipUntil) {\n        if (skipUntilAfter === void 0) { skipUntilAfter = []; }\n        if (skipUntil === void 0) { skipUntil = []; }\n        onError(error);\n        if (skipUntilAfter.length + skipUntil.length > 0) {\n            var token = _scanner.getToken();\n            while (token !== 17 /* EOF */) {\n                if (skipUntilAfter.indexOf(token) !== -1) {\n                    scanNext();\n                    break;\n                }\n                else if (skipUntil.indexOf(token) !== -1) {\n                    break;\n                }\n                token = scanNext();\n            }\n        }\n    }\n    function parseString(isValue) {\n        var value = _scanner.getTokenValue();\n        if (isValue) {\n            onLiteralValue(value);\n        }\n        else {\n            onObjectProperty(value);\n        }\n        scanNext();\n        return true;\n    }\n    function parseLiteral() {\n        switch (_scanner.getToken()) {\n            case 11 /* NumericLiteral */:\n                var tokenValue = _scanner.getTokenValue();\n                var value = Number(tokenValue);\n                if (isNaN(value)) {\n                    handleError(2 /* InvalidNumberFormat */);\n                    value = 0;\n                }\n                onLiteralValue(value);\n                break;\n            case 7 /* NullKeyword */:\n                onLiteralValue(null);\n                break;\n            case 8 /* TrueKeyword */:\n                onLiteralValue(true);\n                break;\n            case 9 /* FalseKeyword */:\n                onLiteralValue(false);\n                break;\n            default:\n                return false;\n        }\n        scanNext();\n        return true;\n    }\n    function parseProperty() {\n        if (_scanner.getToken() !== 10 /* StringLiteral */) {\n            handleError(3 /* PropertyNameExpected */, [], [2 /* CloseBraceToken */, 5 /* CommaToken */]);\n            return false;\n        }\n        parseString(false);\n        if (_scanner.getToken() === 6 /* ColonToken */) {\n            onSeparator(':');\n            scanNext(); // consume colon\n            if (!parseValue()) {\n                handleError(4 /* ValueExpected */, [], [2 /* CloseBraceToken */, 5 /* CommaToken */]);\n            }\n        }\n        else {\n            handleError(5 /* ColonExpected */, [], [2 /* CloseBraceToken */, 5 /* CommaToken */]);\n        }\n        return true;\n    }\n    function parseObject() {\n        onObjectBegin();\n        scanNext(); // consume open brace\n        var needsComma = false;\n        while (_scanner.getToken() !== 2 /* CloseBraceToken */ && _scanner.getToken() !== 17 /* EOF */) {\n            if (_scanner.getToken() === 5 /* CommaToken */) {\n                if (!needsComma) {\n                    handleError(4 /* ValueExpected */, [], []);\n                }\n                onSeparator(',');\n                scanNext(); // consume comma\n                if (_scanner.getToken() === 2 /* CloseBraceToken */ && allowTrailingComma) {\n                    break;\n                }\n            }\n            else if (needsComma) {\n                handleError(6 /* CommaExpected */, [], []);\n            }\n            if (!parseProperty()) {\n                handleError(4 /* ValueExpected */, [], [2 /* CloseBraceToken */, 5 /* CommaToken */]);\n            }\n            needsComma = true;\n        }\n        onObjectEnd();\n        if (_scanner.getToken() !== 2 /* CloseBraceToken */) {\n            handleError(7 /* CloseBraceExpected */, [2 /* CloseBraceToken */], []);\n        }\n        else {\n            scanNext(); // consume close brace\n        }\n        return true;\n    }\n    function parseArray() {\n        onArrayBegin();\n        scanNext(); // consume open bracket\n        var needsComma = false;\n        while (_scanner.getToken() !== 4 /* CloseBracketToken */ && _scanner.getToken() !== 17 /* EOF */) {\n            if (_scanner.getToken() === 5 /* CommaToken */) {\n                if (!needsComma) {\n                    handleError(4 /* ValueExpected */, [], []);\n                }\n                onSeparator(',');\n                scanNext(); // consume comma\n                if (_scanner.getToken() === 4 /* CloseBracketToken */ && allowTrailingComma) {\n                    break;\n                }\n            }\n            else if (needsComma) {\n                handleError(6 /* CommaExpected */, [], []);\n            }\n            if (!parseValue()) {\n                handleError(4 /* ValueExpected */, [], [4 /* CloseBracketToken */, 5 /* CommaToken */]);\n            }\n            needsComma = true;\n        }\n        onArrayEnd();\n        if (_scanner.getToken() !== 4 /* CloseBracketToken */) {\n            handleError(8 /* CloseBracketExpected */, [4 /* CloseBracketToken */], []);\n        }\n        else {\n            scanNext(); // consume close bracket\n        }\n        return true;\n    }\n    function parseValue() {\n        switch (_scanner.getToken()) {\n            case 3 /* OpenBracketToken */:\n                return parseArray();\n            case 1 /* OpenBraceToken */:\n                return parseObject();\n            case 10 /* StringLiteral */:\n                return parseString(true);\n            default:\n                return parseLiteral();\n        }\n    }\n    scanNext();\n    if (_scanner.getToken() === 17 /* EOF */) {\n        if (options.allowEmptyContent) {\n            return true;\n        }\n        handleError(4 /* ValueExpected */, [], []);\n        return false;\n    }\n    if (!parseValue()) {\n        handleError(4 /* ValueExpected */, [], []);\n        return false;\n    }\n    if (_scanner.getToken() !== 17 /* EOF */) {\n        handleError(9 /* EndOfFileExpected */, [], []);\n    }\n    return true;\n}\n\n/*---------------------------------------------------------------------------------------------\n *  Copyright (c) Microsoft Corporation. All rights reserved.\n *  Licensed under the MIT License. See License.txt in the project root for license information.\n *--------------------------------------------------------------------------------------------*/\n/**\n * Parses the given text and returns the object the JSON content represents. On invalid input, the parser tries to be as fault tolerant as possible, but still return a result.\n * Therefore, always check the errors list to find out if the input was valid.\n */\nvar parse = parse$1;\n\nconst isWebWorker = typeof self !== 'undefined' && typeof self.WorkerGlobalScope !== 'undefined';\r\nconst isBrowser = isWebWorker ||\r\n    (typeof window !== 'undefined' &&\r\n        typeof window.document !== 'undefined' &&\r\n        typeof fetch !== 'undefined');\r\n// to be replaced by rollup\r\nlet CDN_ROOT = '';\r\nlet WASM = '';\r\n/**\r\n * Set the route for loading the assets\r\n * URL should end with `/`\r\n *\r\n * For example:\r\n * ```ts\r\n * setCDN('https://unpkg.com/shiki/') // use unpkg\r\n * setCDN('/assets/shiki/') // serve by yourself\r\n * ```\r\n */\r\nfunction setCDN(root) {\r\n    CDN_ROOT = root;\r\n}\r\n/**\r\n * Explicitly set the source for loading the oniguruma web assembly module.\r\n *\r\n * Accepts Url or ArrayBuffer\r\n */\r\nfunction setWasm(path) {\r\n    WASM = path;\r\n}\r\nlet _onigurumaPromise = null;\r\nasync function getOniguruma() {\r\n    if (!_onigurumaPromise) {\r\n        let loader;\r\n        if (isBrowser) {\r\n            if (typeof WASM === 'string') {\r\n                loader = (0,vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__.loadWASM)({\r\n                    data: await fetch(_resolvePath('dist/onig.wasm')).then(r => r.arrayBuffer())\r\n                });\r\n            }\r\n            else {\r\n                loader = (0,vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__.loadWASM)(WASM);\r\n            }\r\n        }\r\n        else {\r\n            const path = __webpack_require__(/*! path */ \"?54c7\");\r\n            const wasmPath = path.join(/*require.resolve*/(/*! vscode-oniguruma */ \"./node_modules/vscode-oniguruma/release/main.js\"), '../onig.wasm');\r\n            const fs = __webpack_require__(/*! fs */ \"?2208\");\r\n            const wasmBin = fs.readFileSync(wasmPath).buffer;\r\n            loader = (0,vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__.loadWASM)(wasmBin);\r\n        }\r\n        _onigurumaPromise = loader.then(() => {\r\n            return {\r\n                createOnigScanner(patterns) {\r\n                    return (0,vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__.createOnigScanner)(patterns);\r\n                },\r\n                createOnigString(s) {\r\n                    return (0,vscode_oniguruma__WEBPACK_IMPORTED_MODULE_0__.createOnigString)(s);\r\n                }\r\n            };\r\n        });\r\n    }\r\n    return _onigurumaPromise;\r\n}\r\nfunction _resolvePath(filepath) {\r\n    if (isBrowser) {\r\n        if (!CDN_ROOT) {\r\n            console.warn('[Shiki] no CDN provider found, use `setCDN()` to specify the CDN for loading the resources before calling `getHighlighter()`');\r\n        }\r\n        return `${CDN_ROOT}${filepath}`;\r\n    }\r\n    else {\r\n        const path = __webpack_require__(/*! path */ \"?54c7\");\r\n        if (path.isAbsolute(filepath)) {\r\n            return filepath;\r\n        }\r\n        else {\r\n            return path.resolve(__dirname, '..', filepath);\r\n        }\r\n    }\r\n}\r\n/**\r\n * @param filepath assert path related to ./packages/shiki\r\n */\r\nasync function _fetchAssets(filepath) {\r\n    const path = _resolvePath(filepath);\r\n    if (isBrowser) {\r\n        return await fetch(path).then(r => r.text());\r\n    }\r\n    else {\r\n        const fs = __webpack_require__(/*! fs */ \"?2208\");\r\n        return await fs.promises.readFile(path, 'utf-8');\r\n    }\r\n}\r\nasync function _fetchJSONAssets(filepath) {\r\n    const errors = [];\r\n    const rawTheme = parse(await _fetchAssets(filepath), errors, {\r\n        allowTrailingComma: true\r\n    });\r\n    if (errors.length) {\r\n        throw errors[0];\r\n    }\r\n    return rawTheme;\r\n}\r\n/**\r\n * @param themePath related path to theme.json\r\n */\r\nasync function fetchTheme(themePath) {\r\n    let theme = await _fetchJSONAssets(themePath);\r\n    const shikiTheme = toShikiTheme(theme);\r\n    if (shikiTheme.include) {\r\n        const includedTheme = await fetchTheme(join(dirname(themePath), shikiTheme.include));\r\n        if (includedTheme.settings) {\r\n            shikiTheme.settings = includedTheme.settings.concat(shikiTheme.settings);\r\n        }\r\n        if (includedTheme.bg && !shikiTheme.bg) {\r\n            shikiTheme.bg = includedTheme.bg;\r\n        }\r\n        if (includedTheme.colors) {\r\n            shikiTheme.colors = Object.assign(Object.assign({}, includedTheme.colors), shikiTheme.colors);\r\n        }\r\n        delete shikiTheme.include;\r\n    }\r\n    return shikiTheme;\r\n}\r\nasync function fetchGrammar(filepath) {\r\n    return await _fetchJSONAssets(filepath);\r\n}\r\nfunction repairTheme(theme) {\r\n    // Has the default no-scope setting with fallback colors\r\n    if (!theme.settings)\r\n        theme.settings = [];\r\n    if (theme.settings[0] && theme.settings[0].settings && !theme.settings[0].scope) {\r\n        return;\r\n    }\r\n    // Push a no-scope setting with fallback colors\r\n    theme.settings.unshift({\r\n        settings: {\r\n            foreground: theme.fg,\r\n            background: theme.bg\r\n        }\r\n    });\r\n}\r\nfunction toShikiTheme(rawTheme) {\r\n    const type = rawTheme.type || 'dark';\r\n    const shikiTheme = Object.assign(Object.assign({ name: rawTheme.name, type }, rawTheme), getThemeDefaultColors(rawTheme));\r\n    if (rawTheme.include) {\r\n        shikiTheme.include = rawTheme.include;\r\n    }\r\n    if (rawTheme.tokenColors) {\r\n        shikiTheme.settings = rawTheme.tokenColors;\r\n        delete shikiTheme.tokenColors;\r\n    }\r\n    repairTheme(shikiTheme);\r\n    return shikiTheme;\r\n}\r\n/**\r\n * https://github.com/microsoft/vscode/blob/f7f05dee53fb33fe023db2e06e30a89d3094488f/src/vs/platform/theme/common/colorRegistry.ts#L258-L268\r\n */\r\nconst VSCODE_FALLBACK_EDITOR_FG = { light: '#333333', dark: '#bbbbbb' };\r\nconst VSCODE_FALLBACK_EDITOR_BG = { light: '#fffffe', dark: '#1e1e1e' };\r\nfunction getThemeDefaultColors(theme) {\r\n    var _a, _b, _c, _d, _e, _f;\r\n    let fg, bg;\r\n    /**\r\n     * First try:\r\n     * Theme might contain a global `tokenColor` without `name` or `scope`\r\n     * Used as default value for foreground/background\r\n     */\r\n    let settings = theme.settings ? theme.settings : theme.tokenColors;\r\n    const globalSetting = settings\r\n        ? settings.find(s => {\r\n            return !s.name && !s.scope;\r\n        })\r\n        : undefined;\r\n    if ((_a = globalSetting === null || globalSetting === void 0 ? void 0 : globalSetting.settings) === null || _a === void 0 ? void 0 : _a.foreground) {\r\n        fg = globalSetting.settings.foreground;\r\n    }\r\n    if ((_b = globalSetting === null || globalSetting === void 0 ? void 0 : globalSetting.settings) === null || _b === void 0 ? void 0 : _b.background) {\r\n        bg = globalSetting.settings.background;\r\n    }\r\n    /**\r\n     * Second try:\r\n     * If there's no global `tokenColor` without `name` or `scope`\r\n     * Use `editor.foreground` and `editor.background`\r\n     */\r\n    if (!fg && ((_d = (_c = theme) === null || _c === void 0 ? void 0 : _c.colors) === null || _d === void 0 ? void 0 : _d['editor.foreground'])) {\r\n        fg = theme.colors['editor.foreground'];\r\n    }\r\n    if (!bg && ((_f = (_e = theme) === null || _e === void 0 ? void 0 : _e.colors) === null || _f === void 0 ? void 0 : _f['editor.background'])) {\r\n        bg = theme.colors['editor.background'];\r\n    }\r\n    /**\r\n     * Last try:\r\n     * If there's no fg/bg color specified in theme, use default\r\n     */\r\n    if (!fg) {\r\n        fg = theme.type === 'light' ? VSCODE_FALLBACK_EDITOR_FG.light : VSCODE_FALLBACK_EDITOR_FG.dark;\r\n    }\r\n    if (!bg) {\r\n        bg = theme.type === 'light' ? VSCODE_FALLBACK_EDITOR_BG.light : VSCODE_FALLBACK_EDITOR_BG.dark;\r\n    }\r\n    return {\r\n        fg,\r\n        bg\r\n    };\r\n}\n\n/*---------------------------------------------------------\r\n * Copyright (C) Microsoft Corporation. All rights reserved.\r\n *--------------------------------------------------------*/\r\nclass Resolver {\r\n    constructor(onigLibPromise, onigLibName) {\r\n        this.languagesPath = 'languages/';\r\n        this.languageMap = {};\r\n        this.scopeToLangMap = {};\r\n        this._onigLibPromise = onigLibPromise;\r\n        this._onigLibName = onigLibName;\r\n    }\r\n    get onigLib() {\r\n        return this._onigLibPromise;\r\n    }\r\n    getOnigLibName() {\r\n        return this._onigLibName;\r\n    }\r\n    getLangRegistration(langIdOrAlias) {\r\n        return this.languageMap[langIdOrAlias];\r\n    }\r\n    async loadGrammar(scopeName) {\r\n        const lang = this.scopeToLangMap[scopeName];\r\n        if (!lang) {\r\n            return null;\r\n        }\r\n        if (lang.grammar) {\r\n            return lang.grammar;\r\n        }\r\n        const g = await fetchGrammar(languages.includes(lang) ? `${this.languagesPath}${lang.path}` : lang.path);\r\n        lang.grammar = g;\r\n        return g;\r\n    }\r\n    addLanguage(l) {\r\n        this.languageMap[l.id] = l;\r\n        if (l.aliases) {\r\n            l.aliases.forEach(a => {\r\n                this.languageMap[a] = l;\r\n            });\r\n        }\r\n        this.scopeToLangMap[l.scopeName] = l;\r\n    }\r\n}\n\n/*---------------------------------------------------------\r\n * Copyright (C) Microsoft Corporation. All rights reserved.\r\n *--------------------------------------------------------*/\r\nfunction tokenizeWithTheme(theme, colorMap, fileContents, grammar, options) {\r\n    let lines = fileContents.split(/\\r\\n|\\r|\\n/);\r\n    let ruleStack = vscode_textmate__WEBPACK_IMPORTED_MODULE_1__.INITIAL;\r\n    let actual = [];\r\n    let final = [];\r\n    for (let i = 0, len = lines.length; i < len; i++) {\r\n        let line = lines[i];\r\n        if (line === '') {\r\n            actual = [];\r\n            final.push([]);\r\n            continue;\r\n        }\r\n        let resultWithScopes;\r\n        let tokensWithScopes;\r\n        let tokensWithScopesIndex;\r\n        if (options.includeExplanation) {\r\n            resultWithScopes = grammar.tokenizeLine(line, ruleStack);\r\n            tokensWithScopes = resultWithScopes.tokens;\r\n            tokensWithScopesIndex = 0;\r\n        }\r\n        let result = grammar.tokenizeLine2(line, ruleStack);\r\n        let tokensLength = result.tokens.length / 2;\r\n        for (let j = 0; j < tokensLength; j++) {\r\n            let startIndex = result.tokens[2 * j];\r\n            let nextStartIndex = j + 1 < tokensLength ? result.tokens[2 * j + 2] : line.length;\r\n            if (startIndex === nextStartIndex) {\r\n                continue;\r\n            }\r\n            let metadata = result.tokens[2 * j + 1];\r\n            let foreground = StackElementMetadata.getForeground(metadata);\r\n            let foregroundColor = colorMap[foreground];\r\n            let fontStyle = StackElementMetadata.getFontStyle(metadata);\r\n            let explanation = [];\r\n            if (options.includeExplanation) {\r\n                let offset = 0;\r\n                while (startIndex + offset < nextStartIndex) {\r\n                    let tokenWithScopes = tokensWithScopes[tokensWithScopesIndex];\r\n                    let tokenWithScopesText = line.substring(tokenWithScopes.startIndex, tokenWithScopes.endIndex);\r\n                    offset += tokenWithScopesText.length;\r\n                    explanation.push({\r\n                        content: tokenWithScopesText,\r\n                        scopes: explainThemeScopes(theme, tokenWithScopes.scopes)\r\n                    });\r\n                    tokensWithScopesIndex++;\r\n                }\r\n            }\r\n            actual.push({\r\n                content: line.substring(startIndex, nextStartIndex),\r\n                color: foregroundColor,\r\n                fontStyle,\r\n                explanation: explanation\r\n            });\r\n        }\r\n        final.push(actual);\r\n        actual = [];\r\n        ruleStack = result.ruleStack;\r\n    }\r\n    return final;\r\n}\r\nfunction explainThemeScopes(theme, scopes) {\r\n    let result = [];\r\n    for (let i = 0, len = scopes.length; i < len; i++) {\r\n        let parentScopes = scopes.slice(0, i);\r\n        let scope = scopes[i];\r\n        result[i] = {\r\n            scopeName: scope,\r\n            themeMatches: explainThemeScope(theme, scope, parentScopes)\r\n        };\r\n    }\r\n    return result;\r\n}\r\nfunction matchesOne(selector, scope) {\r\n    let selectorPrefix = selector + '.';\r\n    if (selector === scope || scope.substring(0, selectorPrefix.length) === selectorPrefix) {\r\n        return true;\r\n    }\r\n    return false;\r\n}\r\nfunction matches(selector, selectorParentScopes, scope, parentScopes) {\r\n    if (!matchesOne(selector, scope)) {\r\n        return false;\r\n    }\r\n    let selectorParentIndex = selectorParentScopes.length - 1;\r\n    let parentIndex = parentScopes.length - 1;\r\n    while (selectorParentIndex >= 0 && parentIndex >= 0) {\r\n        if (matchesOne(selectorParentScopes[selectorParentIndex], parentScopes[parentIndex])) {\r\n            selectorParentIndex--;\r\n        }\r\n        parentIndex--;\r\n    }\r\n    if (selectorParentIndex === -1) {\r\n        return true;\r\n    }\r\n    return false;\r\n}\r\nfunction explainThemeScope(theme, scope, parentScopes) {\r\n    let result = [], resultLen = 0;\r\n    for (let i = 0, len = theme.settings.length; i < len; i++) {\r\n        let setting = theme.settings[i];\r\n        let selectors;\r\n        if (typeof setting.scope === 'string') {\r\n            selectors = setting.scope.split(/,/).map(scope => scope.trim());\r\n        }\r\n        else if (Array.isArray(setting.scope)) {\r\n            selectors = setting.scope;\r\n        }\r\n        else {\r\n            continue;\r\n        }\r\n        for (let j = 0, lenJ = selectors.length; j < lenJ; j++) {\r\n            let rawSelector = selectors[j];\r\n            let rawSelectorPieces = rawSelector.split(/ /);\r\n            let selector = rawSelectorPieces[rawSelectorPieces.length - 1];\r\n            let selectorParentScopes = rawSelectorPieces.slice(0, rawSelectorPieces.length - 1);\r\n            if (matches(selector, selectorParentScopes, scope, parentScopes)) {\r\n                // match!\r\n                result[resultLen++] = setting;\r\n                // break the loop\r\n                j = lenJ;\r\n            }\r\n        }\r\n    }\r\n    return result;\r\n}\n\nfunction renderToHtml(lines, options = {}) {\r\n    var _a;\r\n    const bg = options.bg || '#fff';\r\n    const optionsByLineNumber = groupBy((_a = options.lineOptions) !== null && _a !== void 0 ? _a : [], option => option.line);\r\n    let html = '';\r\n    html += `<pre class=\"shiki\" style=\"background-color: ${bg}\">`;\r\n    if (options.langId) {\r\n        html += `<div class=\"language-id\">${options.langId}</div>`;\r\n    }\r\n    html += `<code>`;\r\n    lines.forEach((l, lineIndex) => {\r\n        var _a;\r\n        const lineNumber = lineIndex + 1;\r\n        const lineOptions = (_a = optionsByLineNumber.get(lineNumber)) !== null && _a !== void 0 ? _a : [];\r\n        const lineClasses = getLineClasses(lineOptions).join(' ');\r\n        html += `<span class=\"${lineClasses}\">`;\r\n        l.forEach(token => {\r\n            const cssDeclarations = [`color: ${token.color || options.fg}`];\r\n            if (token.fontStyle & FontStyle.Italic) {\r\n                cssDeclarations.push('font-style: italic');\r\n            }\r\n            if (token.fontStyle & FontStyle.Bold) {\r\n                cssDeclarations.push('font-weight: bold');\r\n            }\r\n            if (token.fontStyle & FontStyle.Underline) {\r\n                cssDeclarations.push('text-decoration: underline');\r\n            }\r\n            html += `<span style=\"${cssDeclarations.join('; ')}\">${escapeHtml(token.content)}</span>`;\r\n        });\r\n        html += `</span>\\n`;\r\n    });\r\n    html = html.replace(/\\n*$/, ''); // Get rid of final new lines\r\n    html += `</code></pre>`;\r\n    return html;\r\n}\r\nconst htmlEscapes = {\r\n    '&': '&amp;',\r\n    '<': '&lt;',\r\n    '>': '&gt;',\r\n    '\"': '&quot;',\r\n    \"'\": '&#39;'\r\n};\r\nfunction escapeHtml(html) {\r\n    return html.replace(/[&<>\"']/g, chr => htmlEscapes[chr]);\r\n}\r\nfunction getLineClasses(lineOptions) {\r\n    var _a;\r\n    const lineClasses = new Set(['line']);\r\n    for (const lineOption of lineOptions) {\r\n        for (const lineClass of (_a = lineOption.classes) !== null && _a !== void 0 ? _a : []) {\r\n            lineClasses.add(lineClass);\r\n        }\r\n    }\r\n    return Array.from(lineClasses);\r\n}\n\nclass Registry extends vscode_textmate__WEBPACK_IMPORTED_MODULE_1__.Registry {\r\n    constructor(_resolver) {\r\n        super(_resolver);\r\n        this._resolver = _resolver;\r\n        this.themesPath = 'themes/';\r\n        this._resolvedThemes = {};\r\n        this._resolvedGrammars = {};\r\n    }\r\n    getTheme(theme) {\r\n        if (typeof theme === 'string') {\r\n            return this._resolvedThemes[theme];\r\n        }\r\n        else {\r\n            return theme;\r\n        }\r\n    }\r\n    async loadTheme(theme) {\r\n        if (typeof theme === 'string') {\r\n            if (!this._resolvedThemes[theme]) {\r\n                this._resolvedThemes[theme] = await fetchTheme(`${this.themesPath}${theme}.json`);\r\n            }\r\n            return this._resolvedThemes[theme];\r\n        }\r\n        else {\r\n            theme = toShikiTheme(theme);\r\n            if (theme.name) {\r\n                this._resolvedThemes[theme.name] = theme;\r\n            }\r\n            return theme;\r\n        }\r\n    }\r\n    async loadThemes(themes) {\r\n        return await Promise.all(themes.map(theme => this.loadTheme(theme)));\r\n    }\r\n    getLoadedThemes() {\r\n        return Object.keys(this._resolvedThemes);\r\n    }\r\n    getGrammar(name) {\r\n        return this._resolvedGrammars[name];\r\n    }\r\n    async loadLanguage(lang) {\r\n        const g = await this.loadGrammar(lang.scopeName);\r\n        this._resolvedGrammars[lang.id] = g;\r\n        if (lang.aliases) {\r\n            lang.aliases.forEach(la => {\r\n                this._resolvedGrammars[la] = g;\r\n            });\r\n        }\r\n    }\r\n    async loadLanguages(langs) {\r\n        for (const lang of langs) {\r\n            this._resolver.addLanguage(lang);\r\n        }\r\n        for (const lang of langs) {\r\n            await this.loadLanguage(lang);\r\n        }\r\n    }\r\n    getLoadedLanguages() {\r\n        return Object.keys(this._resolvedGrammars);\r\n    }\r\n}\n\nfunction resolveLang(lang) {\r\n    return typeof lang === 'string'\r\n        ? languages.find(l => { var _a; return l.id === lang || ((_a = l.aliases) === null || _a === void 0 ? void 0 : _a.includes(lang)); })\r\n        : lang;\r\n}\r\nfunction resolveOptions(options) {\r\n    var _a;\r\n    let _languages = languages;\r\n    let _themes = options.themes || [];\r\n    if ((_a = options.langs) === null || _a === void 0 ? void 0 : _a.length) {\r\n        _languages = options.langs.map(resolveLang);\r\n    }\r\n    if (options.theme) {\r\n        _themes.unshift(options.theme);\r\n    }\r\n    if (!_themes.length) {\r\n        _themes = ['nord'];\r\n    }\r\n    return { _languages, _themes };\r\n}\r\nasync function getHighlighter(options) {\r\n    var _a, _b;\r\n    const { _languages, _themes } = resolveOptions(options);\r\n    const _resolver = new Resolver(getOniguruma(), 'vscode-oniguruma');\r\n    const _registry = new Registry(_resolver);\r\n    if ((_a = options.paths) === null || _a === void 0 ? void 0 : _a.themes) {\r\n        _registry.themesPath = options.paths.themes;\r\n    }\r\n    if ((_b = options.paths) === null || _b === void 0 ? void 0 : _b.languages) {\r\n        _resolver.languagesPath = options.paths.languages;\r\n    }\r\n    const themes = await _registry.loadThemes(_themes);\r\n    const _defaultTheme = themes[0];\r\n    let _currentTheme;\r\n    await _registry.loadLanguages(_languages);\r\n    /**\r\n     * Shiki was designed for VS Code, so CSS variables are not currently supported.\r\n     * See: https://github.com/shikijs/shiki/pull/212#issuecomment-906924986\r\n     *\r\n     * Instead, we work around this by using valid hex color codes as lookups in a\r\n     * final \"repair\" step which translates those codes to the correct CSS variables.\r\n     */\r\n    const COLOR_REPLACEMENTS = {\r\n        '#000001': 'var(--shiki-color-text)',\r\n        '#000002': 'var(--shiki-color-background)',\r\n        '#000004': 'var(--shiki-token-constant)',\r\n        '#000005': 'var(--shiki-token-string)',\r\n        '#000006': 'var(--shiki-token-comment)',\r\n        '#000007': 'var(--shiki-token-keyword)',\r\n        '#000008': 'var(--shiki-token-parameter)',\r\n        '#000009': 'var(--shiki-token-function)',\r\n        '#000010': 'var(--shiki-token-string-expression)',\r\n        '#000011': 'var(--shiki-token-punctuation)',\r\n        '#000012': 'var(--shiki-token-link)'\r\n    };\r\n    function fixCssVariablesTheme(theme, colorMap) {\r\n        theme.bg = COLOR_REPLACEMENTS[theme.bg] || theme.bg;\r\n        theme.fg = COLOR_REPLACEMENTS[theme.fg] || theme.fg;\r\n        colorMap.forEach((val, i) => {\r\n            colorMap[i] = COLOR_REPLACEMENTS[val] || val;\r\n        });\r\n    }\r\n    function getTheme(theme) {\r\n        const _theme = theme ? _registry.getTheme(theme) : _defaultTheme;\r\n        if (!_theme) {\r\n            throw Error(`No theme registration for ${theme}`);\r\n        }\r\n        if (!_currentTheme || _currentTheme.name !== _theme.name) {\r\n            _registry.setTheme(_theme);\r\n            _currentTheme = _theme;\r\n        }\r\n        const _colorMap = _registry.getColorMap();\r\n        if (_theme.name === 'css-variables') {\r\n            fixCssVariablesTheme(_theme, _colorMap);\r\n        }\r\n        return { _theme, _colorMap };\r\n    }\r\n    function getGrammar(lang) {\r\n        const _grammar = _registry.getGrammar(lang);\r\n        if (!_grammar) {\r\n            throw Error(`No language registration for ${lang}`);\r\n        }\r\n        return { _grammar };\r\n    }\r\n    function codeToThemedTokens(code, lang = 'text', theme, options = { includeExplanation: true }) {\r\n        if (isPlaintext(lang)) {\r\n            const lines = code.split(/\\r\\n|\\r|\\n/);\r\n            return [...lines.map(line => [{ content: line }])];\r\n        }\r\n        const { _grammar } = getGrammar(lang);\r\n        const { _theme, _colorMap } = getTheme(theme);\r\n        return tokenizeWithTheme(_theme, _colorMap, code, _grammar, options);\r\n    }\r\n    function codeToHtml(code, arg1 = 'text', arg2) {\r\n        let options;\r\n        // codeToHtml(code, options?) overload\r\n        if (typeof arg1 === 'object') {\r\n            options = arg1;\r\n        }\r\n        // codeToHtml(code, lang?, theme?) overload\r\n        else {\r\n            options = {\r\n                lang: arg1,\r\n                theme: arg2\r\n            };\r\n        }\r\n        const tokens = codeToThemedTokens(code, options.lang, options.theme, {\r\n            includeExplanation: false\r\n        });\r\n        const { _theme } = getTheme(options.theme);\r\n        return renderToHtml(tokens, {\r\n            fg: _theme.fg,\r\n            bg: _theme.bg,\r\n            lineOptions: options === null || options === void 0 ? void 0 : options.lineOptions\r\n        });\r\n    }\r\n    async function loadTheme(theme) {\r\n        await _registry.loadTheme(theme);\r\n    }\r\n    async function loadLanguage(lang) {\r\n        const _lang = resolveLang(lang);\r\n        _resolver.addLanguage(_lang);\r\n        await _registry.loadLanguage(_lang);\r\n    }\r\n    function getLoadedThemes() {\r\n        return _registry.getLoadedThemes();\r\n    }\r\n    function getLoadedLanguages() {\r\n        return _registry.getLoadedLanguages();\r\n    }\r\n    function getBackgroundColor(theme) {\r\n        const { _theme } = getTheme(theme);\r\n        return _theme.bg;\r\n    }\r\n    function getForegroundColor(theme) {\r\n        const { _theme } = getTheme(theme);\r\n        return _theme.fg;\r\n    }\r\n    return {\r\n        codeToThemedTokens,\r\n        codeToHtml,\r\n        getTheme: (theme) => {\r\n            return getTheme(theme)._theme;\r\n        },\r\n        loadTheme,\r\n        loadLanguage,\r\n        getBackgroundColor,\r\n        getForegroundColor,\r\n        getLoadedThemes,\r\n        getLoadedLanguages\r\n    };\r\n}\r\nfunction isPlaintext(lang) {\r\n    return !lang || ['plaintext', 'txt', 'text'].includes(lang);\r\n}\n\n/** @deprecated use setWasm instead, will be removed in a future version */\r\nfunction setOnigasmWASM(path) {\r\n    setWasm(path);\r\n}\n\n\n\n\n//# sourceURL=webpack://froala-syntax-highlighter/./node_modules/shiki/dist/index.esm.js?")},"./icon/ico.svg":module=>{eval('module.exports = "<svg viewBox=\\"0 0 1792 1792\\" xmlns=\\"http://www.w3.org/2000/svg\\"><path d=\\"M553 1399l-50 50q-10 10-23 10t-23-10l-466-466q-10-10-10-23t10-23l466-466q10-10 23-10t23 10l50 50q10 10 10 23t-10 23l-393 393 393 393q10 10 10 23t-10 23zm591-1067l-373 1291q-4 13-15.5 19.5t-23.5 2.5l-62-17q-13-4-19.5-15.5t-2.5-24.5l373-1291q4-13 15.5-19.5t23.5-2.5l62 17q13 4 19.5 15.5t2.5 24.5zm657 651l-466 466q-10 10-23 10t-23-10l-50-50q-10-10-10-23t10-23l393-393-393-393q-10-10-10-23t10-23l50-50q10-10 23-10t23 10l466 466q10 10 10 23t-10 23z\\"></path></svg>"\n\n//# sourceURL=webpack://froala-syntax-highlighter/./icon/ico.svg?')},"./src/index.ts":(__unused_webpack_module,exports,__webpack_require__)=>{"use strict";eval("\nObject.defineProperty(exports, \"__esModule\", ({ value: true }));\nconst program_language_detector_1 = __webpack_require__(/*! program-language-detector */ \"./node_modules/program-language-detector/dist/programLanguageDetector.es.js\");\nconst shiki = __webpack_require__(/*! shiki */ \"./node_modules/shiki/dist/index.esm.js\");\nconst svg = __webpack_require__(/*! ../icon/ico.svg */ \"./icon/ico.svg\");\nvar FroalaCodeHighlighter;\n(function (FroalaCodeHighlighter) {\n    const CDN_URL = 'https://unpkg.com/shiki/';\n    const DEFAULT_LANG_LIST = ['js', 'ruby', 'c', 'css', 'html', 'python'];\n    const LANG_TYPES = {\n        ...program_language_detector_1.LANG,\n        [program_language_detector_1.LANG['C++']]: 'c',\n    };\n    const { error } = console;\n    const REG_EXP = /[\\u200B-\\u200D\\uFEFF]/g;\n    class IntegrationModel {\n        constructor() {\n            this.highlighter = null;\n            this.defaultLangList = DEFAULT_LANG_LIST;\n            this.loadedLanguages = [];\n            this.defaultTheme = 'min-light';\n            shiki.setCDN(CDN_URL);\n            this.createHighlighter();\n        }\n        cleanEmpty(froalaEl) {\n            const shikiEls = froalaEl.querySelectorAll('.shiki');\n            for (const el of shikiEls) {\n                if (!el.textContent?.trim().replace(REG_EXP, '').length) {\n                    el.remove();\n                }\n                else {\n                    const codeEls = el.querySelectorAll('code');\n                    for (const codeEl of codeEls) {\n                        if (!codeEl.textContent?.trim().replace(REG_EXP, '').length) {\n                            codeEl.remove();\n                        }\n                    }\n                }\n            }\n        }\n        async codeToHtml(source, lang) {\n            if (!this.loadedLanguages.includes(lang)) {\n                await this.highlighter?.loadLanguage(lang);\n                this.loadedLanguages.push(lang);\n            }\n            return `${this.highlighter?.codeToHtml(source, { lang })}<p></p>` || source;\n        }\n        async createHighlighter(langs = [...this.defaultLangList], theme = this.defaultTheme) {\n            try {\n                this.highlighter = await shiki.getHighlighter({ langs, theme });\n                this.loadedLanguages = langs;\n            }\n            catch (e) {\n                if (error) {\n                    error(`Can't create highlighter object - ${e}`);\n                }\n            }\n        }\n    }\n    FroalaCodeHighlighter.IntegrationModel = IntegrationModel;\n    class SyntaxHighlighter {\n        constructor(fe) {\n            this.fe = fe;\n            this.integrationModel = new IntegrationModel();\n            this.createPlugin();\n        }\n        createPlugin() {\n            const { integrationModel } = this;\n            this.fe.PLUGINS.syntaxHighlighter = function ({ clean, html, selection, $el }) {\n                return {\n                    _init: () => { },\n                    highlight: async () => {\n                        try {\n                            const content = selection.get().toString();\n                            const detectedLang = (0, program_language_detector_1.detect)(content);\n                            const lang = LANG_TYPES[detectedLang].toLowerCase();\n                            if (lang === LANG_TYPES.Unknown.toLowerCase()) {\n                                return;\n                            }\n                            let htmlContent = await integrationModel.codeToHtml(content, lang);\n                            htmlContent = clean.html(htmlContent);\n                            html.insert(htmlContent);\n                            html.unwrap();\n                            selection.restore();\n                            const [froalaEl] = $el.get();\n                            integrationModel.cleanEmpty(froalaEl);\n                        }\n                        catch (e) {\n                            if (error) {\n                                error(e);\n                            }\n                        }\n                    },\n                    createHighlighter: async (langs, theme) => {\n                        await integrationModel.createHighlighter(langs, theme);\n                    },\n                };\n            };\n            this.fe.DefineIconTemplate('highlightCodePlugin', '[SVG]');\n            this.fe.DefineIcon('highlightCode', { SVG: svg, template: 'highlightCodePlugin' });\n            this.fe.RegisterCommand('highlightCode', {\n                title: 'Highlight your code',\n                undo: true,\n                focus: false,\n                callback: async function () {\n                    await this.syntaxHighlighter.highlight();\n                },\n            });\n            this.fe.RegisterShortcut(70, 'highlightCode', {});\n        }\n    }\n    FroalaCodeHighlighter.SyntaxHighlighter = SyntaxHighlighter;\n})(FroalaCodeHighlighter || (FroalaCodeHighlighter = {}));\nnew FroalaCodeHighlighter.SyntaxHighlighter(FroalaEditor);\n\n\n//# sourceURL=webpack://froala-syntax-highlighter/./src/index.ts?")},"./node_modules/vscode-oniguruma/release/main.js":function(module){eval('!function(t,n){ true?module.exports=n():0}(this,(function(){return t={770:function(t,n,e){"use strict";var r=this&&this.__importDefault||function(t){return t&&t.__esModule?t:{default:t}};Object.defineProperty(n,"__esModule",{value:!0}),n.setDefaultDebugCall=n.createOnigScanner=n.createOnigString=n.loadWASM=n.OnigScanner=n.OnigString=void 0;const i=r(e(418));let o=null,a=!1;class f{constructor(t){const n=t.length,e=f._utf8ByteLength(t),r=e!==n,i=r?new Uint32Array(n+1):null;r&&(i[n]=e);const o=r?new Uint32Array(e+1):null;r&&(o[e]=n);const a=new Uint8Array(e);let s=0;for(let e=0;e<n;e++){const f=t.charCodeAt(e);let u=f,c=!1;if(f>=55296&&f<=56319&&e+1<n){const n=t.charCodeAt(e+1);n>=56320&&n<=57343&&(u=65536+(f-55296<<10)|n-56320,c=!0)}r&&(i[e]=s,c&&(i[e+1]=s),u<=127?o[s+0]=e:u<=2047?(o[s+0]=e,o[s+1]=e):u<=65535?(o[s+0]=e,o[s+1]=e,o[s+2]=e):(o[s+0]=e,o[s+1]=e,o[s+2]=e,o[s+3]=e)),u<=127?a[s++]=u:u<=2047?(a[s++]=192|(1984&u)>>>6,a[s++]=128|(63&u)>>>0):u<=65535?(a[s++]=224|(61440&u)>>>12,a[s++]=128|(4032&u)>>>6,a[s++]=128|(63&u)>>>0):(a[s++]=240|(1835008&u)>>>18,a[s++]=128|(258048&u)>>>12,a[s++]=128|(4032&u)>>>6,a[s++]=128|(63&u)>>>0),c&&e++}this.utf16Length=n,this.utf8Length=e,this.utf16Value=t,this.utf8Value=a,this.utf16OffsetToUtf8=i,this.utf8OffsetToUtf16=o}static _utf8ByteLength(t){let n=0;for(let e=0,r=t.length;e<r;e++){const i=t.charCodeAt(e);let o=i,a=!1;if(i>=55296&&i<=56319&&e+1<r){const n=t.charCodeAt(e+1);n>=56320&&n<=57343&&(o=65536+(i-55296<<10)|n-56320,a=!0)}n+=o<=127?1:o<=2047?2:o<=65535?3:4,a&&e++}return n}createString(t){const n=t._omalloc(this.utf8Length);return t.HEAPU8.set(this.utf8Value,n),n}}class s{constructor(t){if(this.id=++s.LAST_ID,!o)throw new Error("Must invoke loadWASM first.");this._onigBinding=o,this.content=t;const n=new f(t);this.utf16Length=n.utf16Length,this.utf8Length=n.utf8Length,this.utf16OffsetToUtf8=n.utf16OffsetToUtf8,this.utf8OffsetToUtf16=n.utf8OffsetToUtf16,this.utf8Length<1e4&&!s._sharedPtrInUse?(s._sharedPtr||(s._sharedPtr=o._omalloc(1e4)),s._sharedPtrInUse=!0,o.HEAPU8.set(n.utf8Value,s._sharedPtr),this.ptr=s._sharedPtr):this.ptr=n.createString(o)}convertUtf8OffsetToUtf16(t){return this.utf8OffsetToUtf16?t<0?0:t>this.utf8Length?this.utf16Length:this.utf8OffsetToUtf16[t]:t}convertUtf16OffsetToUtf8(t){return this.utf16OffsetToUtf8?t<0?0:t>this.utf16Length?this.utf8Length:this.utf16OffsetToUtf8[t]:t}dispose(){this.ptr===s._sharedPtr?s._sharedPtrInUse=!1:this._onigBinding._ofree(this.ptr)}}n.OnigString=s,s.LAST_ID=0,s._sharedPtr=0,s._sharedPtrInUse=!1;class u{constructor(t){if(!o)throw new Error("Must invoke loadWASM first.");const n=[],e=[];for(let r=0,i=t.length;r<i;r++){const i=new f(t[r]);n[r]=i.createString(o),e[r]=i.utf8Length}const r=o._omalloc(4*t.length);o.HEAPU32.set(n,r/4);const i=o._omalloc(4*t.length);o.HEAPU32.set(e,i/4);const a=o._createOnigScanner(r,i,t.length);for(let e=0,r=t.length;e<r;e++)o._ofree(n[e]);o._ofree(i),o._ofree(r),0===a&&function(t){throw new Error(t.UTF8ToString(t._getLastOnigError()))}(o),this._onigBinding=o,this._ptr=a}dispose(){this._onigBinding._freeOnigScanner(this._ptr)}findNextMatchSync(t,n,e){let r=a,i=0;if("number"==typeof e?(8&e&&(r=!0),i=e):"boolean"==typeof e&&(r=e),"string"==typeof t){t=new s(t);const e=this._findNextMatchSync(t,n,r,i);return t.dispose(),e}return this._findNextMatchSync(t,n,r,i)}_findNextMatchSync(t,n,e,r){const i=this._onigBinding;let o;if(o=e?i._findNextOnigScannerMatchDbg(this._ptr,t.id,t.ptr,t.utf8Length,t.convertUtf16OffsetToUtf8(n),r):i._findNextOnigScannerMatch(this._ptr,t.id,t.ptr,t.utf8Length,t.convertUtf16OffsetToUtf8(n),r),0===o)return null;const a=i.HEAPU32;let f=o/4;const s=a[f++],u=a[f++];let c=[];for(let n=0;n<u;n++){const e=t.convertUtf8OffsetToUtf16(a[f++]),r=t.convertUtf8OffsetToUtf16(a[f++]);c[n]={start:e,end:r,length:r-e}}return{index:s,captureIndices:c}}}n.OnigScanner=u;let c=!1,l=null;n.loadWASM=function(t){if(c)return l;let n,e,r,a;if(c=!0,function(t){return"function"==typeof t.instantiator}(t))n=t.instantiator,e=t.print;else{let r;!function(t){return void 0!==t.data}(t)?r=t:(r=t.data,e=t.print),n=function(t){return"undefined"!=typeof Response&&t instanceof Response}(r)?"function"==typeof WebAssembly.instantiateStreaming?function(t){return n=>WebAssembly.instantiateStreaming(t,n)}(r):function(t){return async n=>{const e=await t.arrayBuffer();return WebAssembly.instantiate(e,n)}}(r):function(t){return n=>WebAssembly.instantiate(t,n)}(r)}return l=new Promise(((t,n)=>{r=t,a=n})),function(t,n,e,r){i.default({print:n,instantiateWasm:(n,e)=>{if("undefined"==typeof performance){const t=()=>Date.now();n.env.emscripten_get_now=t,n.wasi_snapshot_preview1.emscripten_get_now=t}return t(n).then((t=>e(t.instance)),r),{}}}).then((t=>{o=t,e()}))}(n,e,r,a),l},n.createOnigString=function(t){return new s(t)},n.createOnigScanner=function(t){return new u(t)},n.setDefaultDebugCall=function(t){a=t}},418:t=>{var n=("undefined"!=typeof document&&document.currentScript&&document.currentScript.src,function(t){var n,e,r=void 0!==(t=t||{})?t:{};r.ready=new Promise((function(t,r){n=t,e=r}));var i,o={};for(i in r)r.hasOwnProperty(i)&&(o[i]=r[i]);var a,f=[],s=!1,u=!1,c=!0,l="";function p(t){return r.locateFile?r.locateFile(t,l):l+t}c&&(a=function(t){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(t)):(v("object"==typeof(n=read(t,"binary"))),n)},"undefined"!=typeof scriptArgs?f=scriptArgs:void 0!==arguments&&(f=arguments),"undefined"!=typeof onig_print&&("undefined"==typeof console&&(console={}),console.log=onig_print,console.warn=console.error="undefined"!=typeof printErr?printErr:onig_print));var h=r.print||console.log.bind(console),d=r.printErr||console.warn.bind(console);for(i in o)o.hasOwnProperty(i)&&(r[i]=o[i]);o=null,r.arguments&&(f=r.arguments),r.thisProgram&&r.thisProgram,r.quit&&r.quit;var g,_,m=function(t){};r.wasmBinary&&(g=r.wasmBinary),r.noExitRuntime,"object"!=typeof WebAssembly&&z("no native wasm support detected");var y=!1;function v(t,n){t||z("Assertion failed: "+n)}var w,S,A,b="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function O(t,n,e){for(var r=n+e,i=n;t[i]&&!(i>=r);)++i;if(i-n>16&&t.subarray&&b)return b.decode(t.subarray(n,i));for(var o="";n<i;){var a=t[n++];if(128&a){var f=63&t[n++];if(192!=(224&a)){var s=63&t[n++];if((a=224==(240&a)?(15&a)<<12|f<<6|s:(7&a)<<18|f<<12|s<<6|63&t[n++])<65536)o+=String.fromCharCode(a);else{var u=a-65536;o+=String.fromCharCode(55296|u>>10,56320|1023&u)}}else o+=String.fromCharCode((31&a)<<6|f)}else o+=String.fromCharCode(a)}return o}function U(t,n){return t?O(S,t,n):""}function x(t,n){return t%n>0&&(t+=n-t%n),t}function P(t){w=t,r.HEAP8=new Int8Array(t),r.HEAP16=new Int16Array(t),r.HEAP32=A=new Int32Array(t),r.HEAPU8=S=new Uint8Array(t),r.HEAPU16=new Uint16Array(t),r.HEAPU32=new Uint32Array(t),r.HEAPF32=new Float32Array(t),r.HEAPF64=new Float64Array(t)}"undefined"!=typeof TextDecoder&&new TextDecoder("utf-16le"),r.INITIAL_MEMORY;var T,R=[],E=[],M=[],L=[];function I(){if(r.preRun)for("function"==typeof r.preRun&&(r.preRun=[r.preRun]);r.preRun.length;)N(r.preRun.shift());$(R)}function D(){$(E)}function W(){$(M)}function C(){if(r.postRun)for("function"==typeof r.postRun&&(r.postRun=[r.postRun]);r.postRun.length;)k(r.postRun.shift());$(L)}function N(t){R.unshift(t)}function k(t){L.unshift(t)}E.push({func:function(){ut()}});var B=0,H=null,j=null;function F(t){B++,r.monitorRunDependencies&&r.monitorRunDependencies(B)}function V(t){if(B--,r.monitorRunDependencies&&r.monitorRunDependencies(B),0==B&&(null!==H&&(clearInterval(H),H=null),j)){var n=j;j=null,n()}}function z(t){r.onAbort&&r.onAbort(t),d(t+=""),y=!0,t="abort("+t+"). Build with -s ASSERTIONS=1 for more info.";var n=new WebAssembly.RuntimeError(t);throw e(n),n}function q(t,n){return String.prototype.startsWith?t.startsWith(n):0===t.indexOf(n)}r.preloadedImages={},r.preloadedAudios={};var Y="data:application/octet-stream;base64,";function G(t){return q(t,Y)}var J,K="onig.wasm";function Q(t){try{if(t==K&&g)return new Uint8Array(g);if(a)return a(t);throw"both async and sync fetching of the wasm failed"}catch(t){z(t)}}function X(){return g||!s&&!u||"function"!=typeof fetch?Promise.resolve().then((function(){return Q(K)})):fetch(K,{credentials:"same-origin"}).then((function(t){if(!t.ok)throw"failed to load wasm binary file at \'"+K+"\'";return t.arrayBuffer()})).catch((function(){return Q(K)}))}function Z(){var t={env:st,wasi_snapshot_preview1:st};function n(t,n){var e=t.exports;r.asm=e,P((_=r.asm.memory).buffer),T=r.asm.__indirect_function_table,V()}function i(t){n(t.instance)}function o(n){return X().then((function(n){return WebAssembly.instantiate(n,t)})).then(n,(function(t){d("failed to asynchronously prepare wasm: "+t),z(t)}))}if(F(),r.instantiateWasm)try{return r.instantiateWasm(t,n)}catch(t){return d("Module.instantiateWasm callback failed with error: "+t),!1}return(g||"function"!=typeof WebAssembly.instantiateStreaming||G(K)||"function"!=typeof fetch?o(i):fetch(K,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,t).then(i,(function(t){return d("wasm streaming compile failed: "+t),d("falling back to ArrayBuffer instantiation"),o(i)}))}))).catch(e),{}}function $(t){for(;t.length>0;){var n=t.shift();if("function"!=typeof n){var e=n.func;"number"==typeof e?void 0===n.arg?T.get(e)():T.get(e)(n.arg):e(void 0===n.arg?null:n.arg)}else n(r)}}function tt(t,n,e){S.copyWithin(t,n,n+e)}function nt(){return S.length}function et(t){try{return _.grow(t-w.byteLength+65535>>>16),P(_.buffer),1}catch(t){}}function rt(t){var n=nt(),e=2147483648;if(t>e)return!1;for(var r=1;r<=4;r*=2){var i=n*(1+.2/r);if(i=Math.min(i,t+100663296),et(Math.min(e,x(Math.max(t,i),65536))))return!0}return!1}G(K)||(K=p(K)),J="undefined"!=typeof dateNow?dateNow:function(){return performance.now()};var it={mappings:{},buffers:[null,[],[]],printChar:function(t,n){var e=it.buffers[t];0===n||10===n?((1===t?h:d)(O(e,0)),e.length=0):e.push(n)},varargs:void 0,get:function(){return it.varargs+=4,A[it.varargs-4>>2]},getStr:function(t){return U(t)},get64:function(t,n){return t}};function ot(t,n,e,r){for(var i=0,o=0;o<e;o++){for(var a=A[n+8*o>>2],f=A[n+(8*o+4)>>2],s=0;s<f;s++)it.printChar(t,S[a+s]);i+=f}return A[r>>2]=i,0}function at(t){m(0|t)}var ft,st={emscripten_get_now:J,emscripten_memcpy_big:tt,emscripten_resize_heap:rt,fd_write:ot,setTempRet0:at},ut=(Z(),r.___wasm_call_ctors=function(){return(ut=r.___wasm_call_ctors=r.asm.__wasm_call_ctors).apply(null,arguments)});function ct(t){function e(){ft||(ft=!0,r.calledRun=!0,y||(D(),W(),n(r),r.onRuntimeInitialized&&r.onRuntimeInitialized(),C()))}t=t||f,B>0||(I(),B>0||(r.setStatus?(r.setStatus("Running..."),setTimeout((function(){setTimeout((function(){r.setStatus("")}),1),e()}),1)):e()))}if(r.___errno_location=function(){return(r.___errno_location=r.asm.__errno_location).apply(null,arguments)},r._omalloc=function(){return(r._omalloc=r.asm.omalloc).apply(null,arguments)},r._ofree=function(){return(r._ofree=r.asm.ofree).apply(null,arguments)},r._getLastOnigError=function(){return(r._getLastOnigError=r.asm.getLastOnigError).apply(null,arguments)},r._createOnigScanner=function(){return(r._createOnigScanner=r.asm.createOnigScanner).apply(null,arguments)},r._freeOnigScanner=function(){return(r._freeOnigScanner=r.asm.freeOnigScanner).apply(null,arguments)},r._findNextOnigScannerMatch=function(){return(r._findNextOnigScannerMatch=r.asm.findNextOnigScannerMatch).apply(null,arguments)},r._findNextOnigScannerMatchDbg=function(){return(r._findNextOnigScannerMatchDbg=r.asm.findNextOnigScannerMatchDbg).apply(null,arguments)},r.stackSave=function(){return(r.stackSave=r.asm.stackSave).apply(null,arguments)},r.stackRestore=function(){return(r.stackRestore=r.asm.stackRestore).apply(null,arguments)},r.stackAlloc=function(){return(r.stackAlloc=r.asm.stackAlloc).apply(null,arguments)},r.dynCall_jiji=function(){return(r.dynCall_jiji=r.asm.dynCall_jiji).apply(null,arguments)},r.UTF8ToString=U,j=function t(){ft||ct(),ft||(j=t)},r.run=ct,r.preInit)for("function"==typeof r.preInit&&(r.preInit=[r.preInit]);r.preInit.length>0;)r.preInit.pop()();return ct(),t.ready});t.exports=n}},n={},function e(r){var i=n[r];if(void 0!==i)return i.exports;var o=n[r]={exports:{}};return t[r].call(o.exports,o,o.exports,e),o.exports}(770);var t,n}));\n\n//# sourceURL=webpack://froala-syntax-highlighter/./node_modules/vscode-oniguruma/release/main.js?')},"./node_modules/vscode-textmate/release/main.js":function(module){eval('!function(e,t){ true?module.exports=t():0}(this,(function(){return function(e){var t={};function n(r){if(t[r])return t[r].exports;var i=t[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,n),i.l=!0,i.exports}return n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var i in e)n.d(r,i,function(t){return e[t]}.bind(null,i));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=3)}([function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(1),i=n(5),o=n(6),s=n(2),a="undefined"==typeof performance?function(){return Date.now()}:function(){return performance.now()};t.createGrammar=function(e,t,n,r,i,o){return new v(e,t,n,r,i,o)};var c=function(e){this.scopeName=e};t.FullScopeDependency=c;var u=function(){function e(e,t){this.scopeName=e,this.include=t}return e.prototype.toKey=function(){return this.scopeName+"#"+this.include},e}();t.PartialScopeDependency=u;var l=function(){function e(){this.full=[],this.partial=[],this.visitedRule=new Set,this._seenFull=new Set,this._seenPartial=new Set}return e.prototype.add=function(e){e instanceof c?this._seenFull.has(e.scopeName)||(this._seenFull.add(e.scopeName),this.full.push(e)):this._seenPartial.has(e.toKey())||(this._seenPartial.add(e.toKey()),this.partial.push(e))},e}();function h(e,t,n,i,o){for(var s=0,a=i;s<a.length;s++){var l=a[s];if(!e.visitedRule.has(l)){e.visitedRule.add(l);var d=l.repository?r.mergeObjects({},o,l.repository):o;Array.isArray(l.patterns)&&h(e,t,n,l.patterns,d);var g=l.include;if(g)if("$base"===g||g===t.scopeName)f(e,t,t);else if("$self"===g||g===n.scopeName)f(e,t,n);else if("#"===g.charAt(0))p(e,t,n,g.substring(1),d);else{var m=g.indexOf("#");if(m>=0){var _=g.substring(0,m),y=g.substring(m+1);_===t.scopeName?p(e,t,t,y,d):_===n.scopeName?p(e,t,n,y,d):e.add(new u(_,g.substring(m+1)))}else e.add(new c(g))}}}}function p(e,t,n,r,i){(void 0===i&&(i=n.repository),i&&i[r])&&h(e,t,n,[i[r]],i)}function f(e,t,n){if(n.patterns&&Array.isArray(n.patterns)&&h(e,t,n,n.patterns,n.repository),n.injections){var r=[];for(var i in n.injections)r.push(n.injections[i]);h(e,t,n,r,n.repository)}}function d(e,t){if(!e)return!1;if(e===t)return!0;var n=t.length;return e.length>n&&e.substr(0,n)===t&&"."===e[n]}function g(e,t){if(t.length<e.length)return!1;var n=0;return e.every((function(e){for(var r=n;r<t.length;r++)if(d(t[r],e))return n=r+1,!0;return!1}))}function m(e,t,n,r,s){for(var a=o.createMatchers(t,g),c=i.RuleFactory.getCompiledRuleId(n,r,s.repository),u=0,l=a;u<l.length;u++){var h=l[u];e.push({matcher:h.matcher,ruleId:c,grammar:s,priority:h.priority})}}t.ScopeDependencyCollector=l,t.collectSpecificDependencies=p,t.collectDependencies=f;var _=function(e,t,n,r){this.scopeName=e,this.languageId=t,this.tokenType=n,this.themeData=r};t.ScopeMetadata=_;var y=function(){function e(t,n,r){if(this._initialLanguage=t,this._themeProvider=n,this._cache=new Map,this._defaultMetaData=new _("",this._initialLanguage,0,[this._themeProvider.getDefaults()]),this._embeddedLanguages=Object.create(null),r)for(var i=Object.keys(r),o=0,s=i.length;o<s;o++){var a=i[o],c=r[a];"number"==typeof c&&0!==c?this._embeddedLanguages[a]=c:console.warn("Invalid embedded language found at scope "+a+": <<"+c+">>")}var u=Object.keys(this._embeddedLanguages).map((function(t){return e._escapeRegExpCharacters(t)}));0===u.length?this._embeddedLanguagesRegex=null:(u.sort(),u.reverse(),this._embeddedLanguagesRegex=new RegExp("^(("+u.join(")|(")+"))($|\\\\.)",""))}return e.prototype.onDidChangeTheme=function(){this._cache=new Map,this._defaultMetaData=new _("",this._initialLanguage,0,[this._themeProvider.getDefaults()])},e.prototype.getDefaultMetadata=function(){return this._defaultMetaData},e._escapeRegExpCharacters=function(e){return e.replace(/[\\-\\\\\\{\\}\\*\\+\\?\\|\\^\\$\\.\\,\\[\\]\\(\\)\\#\\s]/g,"\\\\$&")},e.prototype.getMetadataForScope=function(t){if(null===t)return e._NULL_SCOPE_METADATA;var n=this._cache.get(t);return n||(n=this._doGetMetadataForScope(t),this._cache.set(t,n),n)},e.prototype._doGetMetadataForScope=function(e){var t=this._scopeToLanguage(e),n=this._toStandardTokenType(e),r=this._themeProvider.themeMatch(e);return new _(e,t,n,r)},e.prototype._scopeToLanguage=function(e){if(!e)return 0;if(!this._embeddedLanguagesRegex)return 0;var t=e.match(this._embeddedLanguagesRegex);if(!t)return 0;var n=this._embeddedLanguages[t[1]]||0;return n||0},e.prototype._toStandardTokenType=function(t){var n=t.match(e.STANDARD_TOKEN_TYPE_REGEXP);if(!n)return 0;switch(n[1]){case"comment":return 1;case"string":return 2;case"regex":return 4;case"meta.embedded":return 8}throw new Error("Unexpected match for standard token type!")},e._NULL_SCOPE_METADATA=new _("",0,0,null),e.STANDARD_TOKEN_TYPE_REGEXP=/\\b(comment|string|regex|meta\\.embedded)\\b/,e}(),v=function(){function e(e,t,n,r,i,s){if(this._scopeMetadataProvider=new y(t,i,n),this._onigLib=s,this._rootId=-1,this._lastRuleId=0,this._ruleId2desc=[null],this._includedGrammars={},this._grammarRepository=i,this._grammar=C(e,null),this._injections=null,this._tokenTypeMatchers=[],r)for(var a=0,c=Object.keys(r);a<c.length;a++)for(var u=c[a],l=0,h=o.createMatchers(u,g);l<h.length;l++){var p=h[l];this._tokenTypeMatchers.push({matcher:p.matcher,type:r[u]})}}return e.prototype.dispose=function(){for(var e=0,t=this._ruleId2desc;e<t.length;e++){var n=t[e];n&&n.dispose()}},e.prototype.createOnigScanner=function(e){return this._onigLib.createOnigScanner(e)},e.prototype.createOnigString=function(e){return this._onigLib.createOnigString(e)},e.prototype.onDidChangeTheme=function(){this._scopeMetadataProvider.onDidChangeTheme()},e.prototype.getMetadataForScope=function(e){return this._scopeMetadataProvider.getMetadataForScope(e)},e.prototype.getInjections=function(){var e=this;if(null===this._injections){this._injections=[];var t=this._grammar.injections;if(t)for(var n in t)m(this._injections,n,t[n],this,this._grammar);if(this._grammarRepository){var r=this._grammarRepository.injections(this._grammar.scopeName);r&&r.forEach((function(t){var n=e.getExternalGrammar(t);if(n){var r=n.injectionSelector;r&&m(e._injections,r,n,e,n)}}))}this._injections.sort((function(e,t){return e.priority-t.priority}))}return this._injections},e.prototype.registerRule=function(e){var t=++this._lastRuleId,n=e(t);return this._ruleId2desc[t]=n,n},e.prototype.getRule=function(e){return this._ruleId2desc[e]},e.prototype.getExternalGrammar=function(e,t){if(this._includedGrammars[e])return this._includedGrammars[e];if(this._grammarRepository){var n=this._grammarRepository.lookup(e);if(n)return this._includedGrammars[e]=C(n,t&&t.$base),this._includedGrammars[e]}return null},e.prototype.tokenizeLine=function(e,t){var n=this._tokenize(e,t,!1);return{tokens:n.lineTokens.getResult(n.ruleStack,n.lineLength),ruleStack:n.ruleStack}},e.prototype.tokenizeLine2=function(e,t){var n=this._tokenize(e,t,!0);return{tokens:n.lineTokens.getBinaryResult(n.ruleStack,n.lineLength),ruleStack:n.ruleStack}},e.prototype._tokenize=function(e,t,n){var r;if(-1===this._rootId&&(this._rootId=i.RuleFactory.getCompiledRuleId(this._grammar.repository.$self,this,this._grammar.repository)),t&&t!==I.NULL)r=!1,t.reset();else{r=!0;var o=this._scopeMetadataProvider.getDefaultMetadata(),s=o.themeData[0],a=P.set(0,o.languageId,o.tokenType,s.fontStyle,s.foreground,s.background),c=this.getRule(this._rootId).getName(null,null),u=this._scopeMetadataProvider.getMetadataForScope(c),l=x.mergeMetadata(a,null,u),h=new x(null,null===c?"unknown":c,l);t=new I(null,this._rootId,-1,-1,!1,null,h,h)}e+="\\n";var p=this.createOnigString(e),f=p.content.length,d=new T(n,e,this._tokenTypeMatchers),g=S(this,p,r,0,t,d,!0);return b(p),{lineLength:f,lineTokens:d,ruleStack:g}},e}();function b(e){"function"==typeof e.dispose&&e.dispose()}function C(e,t){return(e=r.clone(e)).repository=e.repository||{},e.repository.$self={$vscodeTextmateLocation:e.$vscodeTextmateLocation,patterns:e.patterns,name:e.scopeName},e.repository.$base=t||e.repository.$self,e}function w(e,t,n,r,i,o,s){if(0!==o.length){for(var a=t.content,c=Math.min(o.length,s.length),u=[],l=s[0].end,h=0;h<c;h++){var p=o[h];if(null!==p){var f=s[h];if(0!==f.length){if(f.start>l)break;for(;u.length>0&&u[u.length-1].endPos<=f.start;)i.produceFromScopes(u[u.length-1].scopes,u[u.length-1].endPos),u.pop();if(u.length>0?i.produceFromScopes(u[u.length-1].scopes,f.start):i.produce(r,f.start),p.retokenizeCapturedWithRuleId){var d=p.getName(a,s),g=r.contentNameScopesList.push(e,d),m=p.getContentName(a,s),_=g.push(e,m),y=r.push(p.retokenizeCapturedWithRuleId,f.start,-1,!1,null,g,_),v=e.createOnigString(a.substring(0,f.end));S(e,v,n&&0===f.start,f.start,y,i,!1),b(v)}else{var C=p.getName(a,s);if(null!==C){var w=(u.length>0?u[u.length-1].scopes:r.contentNameScopesList).push(e,C);u.push(new A(w,f.end))}}}}}for(;u.length>0;)i.produceFromScopes(u[u.length-1].scopes,u[u.length-1].endPos),u.pop()}}function k(e){for(var t=[],n=0,r=e.rules.length;n<r;n++)t.push("   - "+e.rules[n]+": "+e.debugRegExps[n]);return t.join("\\n")}function R(e,t,n,r,i,o){var c=function(e,t,n,r,i,o){var c=i.getRule(e),u=c.compile(e,i.endRule,n,r===o),l=0;s.DebugFlags.InDebugMode&&(l=a());var h=u.scanner.findNextMatchSync(t,r);if(s.DebugFlags.InDebugMode){var p=a()-l;p>5&&console.warn("Rule "+c.debugName+" ("+c.id+") matching took "+p+" against \'"+t+"\'"),h&&console.log("matched rule id: "+u.rules[h.index]+" from "+h.captureIndices[0].start+" to "+h.captureIndices[0].end)}return h?{captureIndices:h.captureIndices,matchedRuleId:u.rules[h.index]}:null}(e,t,n,r,i,o),u=e.getInjections();if(0===u.length)return c;var l=function(e,t,n,r,i,o,a){for(var c,u=Number.MAX_VALUE,l=null,h=0,p=o.contentNameScopesList.generateScopes(),f=0,d=e.length;f<d;f++){var g=e[f];if(g.matcher(p)){var m=t.getRule(g.ruleId).compile(t,null,r,i===a),_=m.scanner.findNextMatchSync(n,i);if(s.DebugFlags.InDebugMode&&(console.log("  scanning for injections"),console.log(k(m))),_){var y=_.captureIndices[0].start;if(!(y>=u)&&(u=y,l=_.captureIndices,c=m.rules[_.index],h=g.priority,u===i))break}}}return l?{priorityMatch:-1===h,captureIndices:l,matchedRuleId:c}:null}(u,e,t,n,r,i,o);if(!l)return c;if(!c)return l;var h=c.captureIndices[0].start,p=l.captureIndices[0].start;return p<h||l.priorityMatch&&p===h?l:c}function S(e,t,n,r,o,a,c){var u=t.content.length,l=!1,h=-1;if(c){var p=function(e,t,n,r,o,a){for(var c=o.beginRuleCapturedEOL?0:-1,u=[],l=o;l;l=l.pop()){var h=l.getRule(e);h instanceof i.BeginWhileRule&&u.push({rule:h,stack:l})}for(var p=u.pop();p;p=u.pop()){var f=p.rule.compileWhile(e,p.stack.endRule,n,c===r),d=f.scanner.findNextMatchSync(t,r);if(s.DebugFlags.InDebugMode&&(console.log("  scanning for while rule"),console.log(k(f))),!d){s.DebugFlags.InDebugMode&&console.log("  popping "+p.rule.debugName+" - "+p.rule.debugWhileRegExp),o=p.stack.pop();break}if(-2!==f.rules[d.index]){o=p.stack.pop();break}d.captureIndices&&d.captureIndices.length&&(a.produce(p.stack,d.captureIndices[0].start),w(e,t,n,p.stack,a,p.rule.whileCaptures,d.captureIndices),a.produce(p.stack,d.captureIndices[0].end),c=d.captureIndices[0].end,d.captureIndices[0].end>r&&(r=d.captureIndices[0].end,n=!1))}return{stack:o,linePos:r,anchorPosition:c,isFirstLine:n}}(e,t,n,r,o,a);o=p.stack,r=p.linePos,n=p.isFirstLine,h=p.anchorPosition}for(;!l;)f();function f(){s.DebugFlags.InDebugMode&&(console.log(""),console.log("@@scanNext "+r+": |"+t.content.substr(r).replace(/\\n$/,"\\\\n")+"|"));var c=R(e,t,n,r,o,h);if(!c)return s.DebugFlags.InDebugMode&&console.log("  no more matches."),a.produce(o,u),void(l=!0);var p=c.captureIndices,f=c.matchedRuleId,d=!!(p&&p.length>0)&&p[0].end>r;if(-1===f){var g=o.getRule(e);s.DebugFlags.InDebugMode&&console.log("  popping "+g.debugName+" - "+g.debugEndRegExp),a.produce(o,p[0].start),o=o.setContentNameScopesList(o.nameScopesList),w(e,t,n,o,a,g.endCaptures,p),a.produce(o,p[0].end);var m=o;if(o=o.pop(),h=m.getAnchorPos(),!d&&m.getEnterPos()===r)return s.DebugFlags.InDebugMode&&console.error("[1] - Grammar is in an endless loop - Grammar pushed & popped a rule without advancing"),o=m,a.produce(o,u),void(l=!0)}else{var _=e.getRule(f);a.produce(o,p[0].start);var y=o,v=_.getName(t.content,p),b=o.contentNameScopesList.push(e,v);if(o=o.push(f,r,h,p[0].end===u,null,b,b),_ instanceof i.BeginEndRule){var C=_;s.DebugFlags.InDebugMode&&console.log("  pushing "+C.debugName+" - "+C.debugBeginRegExp),w(e,t,n,o,a,C.beginCaptures,p),a.produce(o,p[0].end),h=p[0].end;var k=C.getContentName(t.content,p),S=b.push(e,k);if(o=o.setContentNameScopesList(S),C.endHasBackReferences&&(o=o.setEndRule(C.getEndWithResolvedBackReferences(t.content,p))),!d&&y.hasSameRuleAs(o))return s.DebugFlags.InDebugMode&&console.error("[2] - Grammar is in an endless loop - Grammar pushed the same rule without advancing"),o=o.pop(),a.produce(o,u),void(l=!0)}else if(_ instanceof i.BeginWhileRule){C=_;s.DebugFlags.InDebugMode&&console.log("  pushing "+C.debugName),w(e,t,n,o,a,C.beginCaptures,p),a.produce(o,p[0].end),h=p[0].end;k=C.getContentName(t.content,p),S=b.push(e,k);if(o=o.setContentNameScopesList(S),C.whileHasBackReferences&&(o=o.setEndRule(C.getWhileWithResolvedBackReferences(t.content,p))),!d&&y.hasSameRuleAs(o))return s.DebugFlags.InDebugMode&&console.error("[3] - Grammar is in an endless loop - Grammar pushed the same rule without advancing"),o=o.pop(),a.produce(o,u),void(l=!0)}else{var P=_;if(s.DebugFlags.InDebugMode&&console.log("  matched "+P.debugName+" - "+P.debugMatchRegExp),w(e,t,n,o,a,P.captures,p),a.produce(o,p[0].end),o=o.pop(),!d)return s.DebugFlags.InDebugMode&&console.error("[4] - Grammar is in an endless loop - Grammar is not advancing, nor is it pushing/popping"),o=o.safePop(),a.produce(o,u),void(l=!0)}}p[0].end>r&&(r=p[0].end,n=!1)}return o}t.Grammar=v;var P=function(){function e(){}return e.toBinaryStr=function(e){for(var t=e.toString(2);t.length<32;)t="0"+t;return t},e.printMetadata=function(t){var n=e.getLanguageId(t),r=e.getTokenType(t),i=e.getFontStyle(t),o=e.getForeground(t),s=e.getBackground(t);console.log({languageId:n,tokenType:r,fontStyle:i,foreground:o,background:s})},e.getLanguageId=function(e){return(255&e)>>>0},e.getTokenType=function(e){return(1792&e)>>>8},e.getFontStyle=function(e){return(14336&e)>>>11},e.getForeground=function(e){return(8372224&e)>>>14},e.getBackground=function(e){return(4286578688&e)>>>23},e.set=function(t,n,r,i,o,s){var a=e.getLanguageId(t),c=e.getTokenType(t),u=e.getFontStyle(t),l=e.getForeground(t),h=e.getBackground(t);return 0!==n&&(a=n),0!==r&&(c=8===r?0:r),-1!==i&&(u=i),0!==o&&(l=o),0!==s&&(h=s),(a<<0|c<<8|u<<11|l<<14|h<<23)>>>0},e}();t.StackElementMetadata=P;var x=function(){function e(e,t,n){this.parent=e,this.scope=t,this.metadata=n}return e._equals=function(e,t){for(;;){if(e===t)return!0;if(!e&&!t)return!0;if(!e||!t)return!1;if(e.scope!==t.scope||e.metadata!==t.metadata)return!1;e=e.parent,t=t.parent}},e.prototype.equals=function(t){return e._equals(this,t)},e._matchesScope=function(e,t,n){return t===e||e.substring(0,n.length)===n},e._matches=function(e,t){if(null===t)return!0;for(var n=t.length,r=0,i=t[r],o=i+".";e;){if(this._matchesScope(e.scope,i,o)){if(++r===n)return!0;o=(i=t[r])+"."}e=e.parent}return!1},e.mergeMetadata=function(e,t,n){if(null===n)return e;var r=-1,i=0,o=0;if(null!==n.themeData)for(var s=0,a=n.themeData.length;s<a;s++){var c=n.themeData[s];if(this._matches(t,c.parentScopes)){r=c.fontStyle,i=c.foreground,o=c.background;break}}return P.set(e,n.languageId,n.tokenType,r,i,o)},e._push=function(t,n,r){for(var i=0,o=r.length;i<o;i++){var s=r[i],a=n.getMetadataForScope(s),c=e.mergeMetadata(t.metadata,t,a);t=new e(t,s,c)}return t},e.prototype.push=function(t,n){return null===n?this:n.indexOf(" ")>=0?e._push(this,t,n.split(/ /g)):e._push(this,t,[n])},e._generateScopes=function(e){for(var t=[],n=0;e;)t[n++]=e.scope,e=e.parent;return t.reverse(),t},e.prototype.generateScopes=function(){return e._generateScopes(this)},e}();t.ScopeListElement=x;var I=function(){function e(e,t,n,r,i,o,s,a){this.parent=e,this.depth=this.parent?this.parent.depth+1:1,this.ruleId=t,this._enterPos=n,this._anchorPos=r,this.beginRuleCapturedEOL=i,this.endRule=o,this.nameScopesList=s,this.contentNameScopesList=a}return e._structuralEquals=function(e,t){for(;;){if(e===t)return!0;if(!e&&!t)return!0;if(!e||!t)return!1;if(e.depth!==t.depth||e.ruleId!==t.ruleId||e.endRule!==t.endRule)return!1;e=e.parent,t=t.parent}},e._equals=function(e,t){return e===t||!!this._structuralEquals(e,t)&&e.contentNameScopesList.equals(t.contentNameScopesList)},e.prototype.clone=function(){return this},e.prototype.equals=function(t){return null!==t&&e._equals(this,t)},e._reset=function(e){for(;e;)e._enterPos=-1,e._anchorPos=-1,e=e.parent},e.prototype.reset=function(){e._reset(this)},e.prototype.pop=function(){return this.parent},e.prototype.safePop=function(){return this.parent?this.parent:this},e.prototype.push=function(t,n,r,i,o,s,a){return new e(this,t,n,r,i,o,s,a)},e.prototype.getEnterPos=function(){return this._enterPos},e.prototype.getAnchorPos=function(){return this._anchorPos},e.prototype.getRule=function(e){return e.getRule(this.ruleId)},e.prototype._writeString=function(e,t){return this.parent&&(t=this.parent._writeString(e,t)),e[t++]="("+this.ruleId+", TODO-"+this.nameScopesList+", TODO-"+this.contentNameScopesList+")",t},e.prototype.toString=function(){var e=[];return this._writeString(e,0),"["+e.join(",")+"]"},e.prototype.setContentNameScopesList=function(e){return this.contentNameScopesList===e?this:this.parent.push(this.ruleId,this._enterPos,this._anchorPos,this.beginRuleCapturedEOL,this.endRule,this.nameScopesList,e)},e.prototype.setEndRule=function(t){return this.endRule===t?this:new e(this.parent,this.ruleId,this._enterPos,this._anchorPos,this.beginRuleCapturedEOL,t,this.nameScopesList,this.contentNameScopesList)},e.prototype.hasSameRuleAs=function(e){return this.ruleId===e.ruleId},e.NULL=new e(null,0,0,0,!1,null,null,null),e}();t.StackElement=I;var A=function(e,t){this.scopes=e,this.endPos=t};t.LocalStackElement=A;var T=function(){function e(e,t,n){this._emitBinaryTokens=e,this._tokenTypeOverrides=n,s.DebugFlags.InDebugMode?this._lineText=t:this._lineText=null,this._tokens=[],this._binaryTokens=[],this._lastTokenEndIndex=0}return e.prototype.produce=function(e,t){this.produceFromScopes(e.contentNameScopesList,t)},e.prototype.produceFromScopes=function(e,t){if(!(this._lastTokenEndIndex>=t)){if(this._emitBinaryTokens){for(var n=e.metadata,r=0,i=this._tokenTypeOverrides;r<i.length;r++){var o=i[r];o.matcher(e.generateScopes())&&(n=P.set(n,0,L(o.type),-1,0,0))}return this._binaryTokens.length>0&&this._binaryTokens[this._binaryTokens.length-1]===n||(this._binaryTokens.push(this._lastTokenEndIndex),this._binaryTokens.push(n)),void(this._lastTokenEndIndex=t)}var a=e.generateScopes();if(s.DebugFlags.InDebugMode){console.log("  token: |"+this._lineText.substring(this._lastTokenEndIndex,t).replace(/\\n$/,"\\\\n")+"|");for(var c=0;c<a.length;c++)console.log("      * "+a[c])}this._tokens.push({startIndex:this._lastTokenEndIndex,endIndex:t,scopes:a}),this._lastTokenEndIndex=t}},e.prototype.getResult=function(e,t){return this._tokens.length>0&&this._tokens[this._tokens.length-1].startIndex===t-1&&this._tokens.pop(),0===this._tokens.length&&(this._lastTokenEndIndex=-1,this.produce(e,t),this._tokens[this._tokens.length-1].startIndex=0),this._tokens},e.prototype.getBinaryResult=function(e,t){this._binaryTokens.length>0&&this._binaryTokens[this._binaryTokens.length-2]===t-1&&(this._binaryTokens.pop(),this._binaryTokens.pop()),0===this._binaryTokens.length&&(this._lastTokenEndIndex=-1,this.produce(e,t),this._binaryTokens[this._binaryTokens.length-2]=0);for(var n=new Uint32Array(this._binaryTokens.length),r=0,i=this._binaryTokens.length;r<i;r++)n[r]=this._binaryTokens[r];return n},e}();function L(e){switch(e){case 4:return 4;case 2:return 2;case 1:return 1;case 0:default:return 8}}},function(e,t,n){"use strict";function r(e){return Array.isArray(e)?function(e){for(var t=[],n=0,i=e.length;n<i;n++)t[n]=r(e[n]);return t}(e):"object"==typeof e?function(e){var t={};for(var n in e)t[n]=r(e[n]);return t}(e):e}Object.defineProperty(t,"__esModule",{value:!0}),t.clone=function(e){return r(e)},t.mergeObjects=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];return t.forEach((function(t){for(var n in t)e[n]=t[n]})),e},t.basename=function e(t){var n=~t.lastIndexOf("/")||~t.lastIndexOf("\\\\");return 0===n?t:~n==t.length-1?e(t.substring(0,t.length-1)):t.substr(1+~n)};var i=/\\$(\\d+)|\\${(\\d+):\\/(downcase|upcase)}/,o=function(){function e(){}return e.hasCaptures=function(e){return null!==e&&i.test(e)},e.replaceCaptures=function(e,t,n){return e.replace(i,(function(e,r,i,o){var s=n[parseInt(r||i,10)];if(!s)return e;for(var a=t.substring(s.start,s.end);"."===a[0];)a=a.substring(1);switch(o){case"downcase":return a.toLowerCase();case"upcase":return a.toUpperCase();default:return a}}))},e}();t.RegexSource=o},function(e,t,n){"use strict";(function(e){Object.defineProperty(t,"__esModule",{value:!0}),t.DebugFlags={InDebugMode:void 0!==e&&!!e.env.VSCODE_TEXTMATE_DEBUG}}).call(this,n(7))},function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function s(e){try{c(r.next(e))}catch(e){o(e)}}function a(e){try{c(r.throw(e))}catch(e){o(e)}}function c(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(s,a)}c((r=r.apply(e,t||[])).next())}))},i=this&&this.__generator||function(e,t){var n,r,i,o,s={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:a(0),throw:a(1),return:a(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function a(o){return function(a){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;s;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return s.label++,{value:o[1],done:!1};case 5:s.label++,r=o[1],o=[0];continue;case 7:o=s.ops.pop(),s.trys.pop();continue;default:if(!(i=s.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){s=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){s.label=o[1];break}if(6===o[0]&&s.label<i[1]){s.label=i[1],i=o;break}if(i&&s.label<i[2]){s.label=i[2],s.ops.push(o);break}i[2]&&s.ops.pop(),s.trys.pop();continue}o=t.call(e,s)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,a])}}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(4),s=n(8),a=n(11),c=n(0),u=function(){function e(e){this._options=e,this._syncRegistry=new o.SyncRegistry(a.Theme.createFromRawTheme(e.theme,e.colorMap),e.onigLib),this._ensureGrammarCache=new Map}return e.prototype.dispose=function(){this._syncRegistry.dispose()},e.prototype.setTheme=function(e,t){this._syncRegistry.setTheme(a.Theme.createFromRawTheme(e,t))},e.prototype.getColorMap=function(){return this._syncRegistry.getColorMap()},e.prototype.loadGrammarWithEmbeddedLanguages=function(e,t,n){return this.loadGrammarWithConfiguration(e,t,{embeddedLanguages:n})},e.prototype.loadGrammarWithConfiguration=function(e,t,n){return this._loadGrammar(e,t,n.embeddedLanguages,n.tokenTypes)},e.prototype.loadGrammar=function(e){return this._loadGrammar(e,0,null,null)},e.prototype._doLoadSingleGrammar=function(e){return r(this,void 0,void 0,(function(){var t,n;return i(this,(function(r){switch(r.label){case 0:return[4,this._options.loadGrammar(e)];case 1:return(t=r.sent())&&(n="function"==typeof this._options.getInjections?this._options.getInjections(e):void 0,this._syncRegistry.addGrammar(t,n)),[2]}}))}))},e.prototype._loadSingleGrammar=function(e){return r(this,void 0,void 0,(function(){return i(this,(function(t){return this._ensureGrammarCache.has(e)||this._ensureGrammarCache.set(e,this._doLoadSingleGrammar(e)),[2,this._ensureGrammarCache.get(e)]}))}))},e.prototype._collectDependenciesForDep=function(e,t,n){var r=this._syncRegistry.lookup(n.scopeName);if(r){n instanceof c.FullScopeDependency?c.collectDependencies(t,this._syncRegistry.lookup(e),r):c.collectSpecificDependencies(t,this._syncRegistry.lookup(e),r,n.include);var i=this._syncRegistry.injections(n.scopeName);if(i)for(var o=0,s=i;o<s.length;o++){var a=s[o];t.add(new c.FullScopeDependency(a))}}else if(n.scopeName===e)throw new Error("No grammar provided for <"+e+">")},e.prototype._loadGrammar=function(e,t,n,o){return r(this,void 0,void 0,(function(){var r,s,a,u,l,h,p,f,d,g,m,_,y=this;return i(this,(function(i){switch(i.label){case 0:r=new Set,s=new Set,r.add(e),a=[new c.FullScopeDependency(e)],i.label=1;case 1:return a.length>0?(u=a,a=[],[4,Promise.all(u.map((function(e){return y._loadSingleGrammar(e.scopeName)})))]):[3,3];case 2:for(i.sent(),l=new c.ScopeDependencyCollector,h=0,p=u;h<p.length;h++)_=p[h],this._collectDependenciesForDep(e,l,_);for(f=0,d=l.full;f<d.length;f++)_=d[f],r.has(_.scopeName)||(r.add(_.scopeName),a.push(_));for(g=0,m=l.partial;g<m.length;g++)_=m[g],r.has(_.scopeName)||s.has(_.toKey())||(s.add(_.toKey()),a.push(_));return[3,1];case 3:return[2,this.grammarForScopeName(e,t,n,o)]}}))}))},e.prototype.addGrammar=function(e,t,n,o){return void 0===t&&(t=[]),void 0===n&&(n=0),void 0===o&&(o=null),r(this,void 0,void 0,(function(){return i(this,(function(r){switch(r.label){case 0:return this._syncRegistry.addGrammar(e,t),[4,this.grammarForScopeName(e.scopeName,n,o)];case 1:return[2,r.sent()]}}))}))},e.prototype.grammarForScopeName=function(e,t,n,r){return void 0===t&&(t=0),void 0===n&&(n=null),void 0===r&&(r=null),this._syncRegistry.grammarForScopeName(e,t,n,r)},e}();t.Registry=u,t.INITIAL=c.StackElement.NULL,t.parseRawGrammar=s.parseRawGrammar},function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function s(e){try{c(r.next(e))}catch(e){o(e)}}function a(e){try{c(r.throw(e))}catch(e){o(e)}}function c(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(s,a)}c((r=r.apply(e,t||[])).next())}))},i=this&&this.__generator||function(e,t){var n,r,i,o,s={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:a(0),throw:a(1),return:a(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function a(o){return function(a){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;s;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return s.label++,{value:o[1],done:!1};case 5:s.label++,r=o[1],o=[0];continue;case 7:o=s.ops.pop(),s.trys.pop();continue;default:if(!(i=s.trys,(i=i.length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){s=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){s.label=o[1];break}if(6===o[0]&&s.label<i[1]){s.label=i[1],i=o;break}if(i&&s.label<i[2]){s.label=i[2],s.ops.push(o);break}i[2]&&s.ops.pop(),s.trys.pop();continue}o=t.call(e,s)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,a])}}};Object.defineProperty(t,"__esModule",{value:!0});var o=n(0),s=function(){function e(e,t){this._theme=e,this._grammars={},this._rawGrammars={},this._injectionGrammars={},this._onigLibPromise=t}return e.prototype.dispose=function(){for(var e in this._grammars)this._grammars.hasOwnProperty(e)&&this._grammars[e].dispose()},e.prototype.setTheme=function(e){var t=this;this._theme=e,Object.keys(this._grammars).forEach((function(e){t._grammars[e].onDidChangeTheme()}))},e.prototype.getColorMap=function(){return this._theme.getColorMap()},e.prototype.addGrammar=function(e,t){this._rawGrammars[e.scopeName]=e,t&&(this._injectionGrammars[e.scopeName]=t)},e.prototype.lookup=function(e){return this._rawGrammars[e]},e.prototype.injections=function(e){return this._injectionGrammars[e]},e.prototype.getDefaults=function(){return this._theme.getDefaults()},e.prototype.themeMatch=function(e){return this._theme.match(e)},e.prototype.grammarForScopeName=function(e,t,n,s){return r(this,void 0,void 0,(function(){var r,a,c,u,l;return i(this,(function(i){switch(i.label){case 0:return this._grammars[e]?[3,2]:(r=this._rawGrammars[e])?(a=this._grammars,c=e,u=o.createGrammar,l=[r,t,n,s,this],[4,this._onigLibPromise]):[2,null];case 1:a[c]=u.apply(void 0,l.concat([i.sent()])),i.label=2;case 2:return[2,this._grammars[e]]}}))}))},e}();t.SyncRegistry=s},function(e,t,n){"use strict";var r,i=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0});var o=n(1),s=/\\\\(\\d+)/,a=/\\\\(\\d+)/g,c=function(){function e(e,t,n){this.debugRegExps=t,this.rules=n,this.scanner=e.createOnigScanner(t)}return e.prototype.dispose=function(){"function"==typeof this.scanner.dispose&&this.scanner.dispose()},e}();t.CompiledRule=c;var u=function(){function e(e,t,n,r){this.$location=e,this.id=t,this._name=n||null,this._nameIsCapturing=o.RegexSource.hasCaptures(this._name),this._contentName=r||null,this._contentNameIsCapturing=o.RegexSource.hasCaptures(this._contentName)}return Object.defineProperty(e.prototype,"debugName",{get:function(){var e=this.$location?o.basename(this.$location.filename)+":"+this.$location.line:"unknown";return this.constructor.name+"#"+this.id+" @ "+e},enumerable:!0,configurable:!0}),e.prototype.getName=function(e,t){return this._nameIsCapturing&&null!==this._name&&null!==e&&null!==t?o.RegexSource.replaceCaptures(this._name,e,t):this._name},e.prototype.getContentName=function(e,t){return this._contentNameIsCapturing&&null!==this._contentName?o.RegexSource.replaceCaptures(this._contentName,e,t):this._contentName},e}();t.Rule=u;var l=function(e){function t(t,n,r,i,o){var s=e.call(this,t,n,r,i)||this;return s.retokenizeCapturedWithRuleId=o,s}return i(t,e),t.prototype.dispose=function(){},t.prototype.collectPatternsRecursive=function(e,t,n){throw new Error("Not supported!")},t.prototype.compile=function(e,t,n,r){throw new Error("Not supported!")},t}(u);t.CaptureRule=l;var h=function(){function e(e,t,n){if(void 0===n&&(n=!0),n)if(e){for(var r=e.length,i=0,o=[],a=!1,c=0;c<r;c++){if("\\\\"===e.charAt(c)&&c+1<r){var u=e.charAt(c+1);"z"===u?(o.push(e.substring(i,c)),o.push("$(?!\\\\n)(?<!\\\\n)"),i=c+2):"A"!==u&&"G"!==u||(a=!0),c++}}this.hasAnchor=a,0===i?this.source=e:(o.push(e.substring(i,r)),this.source=o.join(""))}else this.hasAnchor=!1,this.source=e;else this.hasAnchor=!1,this.source=e;this.hasAnchor?this._anchorCache=this._buildAnchorCache():this._anchorCache=null,this.ruleId=t,this.hasBackReferences=s.test(this.source)}return e.prototype.clone=function(){return new e(this.source,this.ruleId,!0)},e.prototype.setSource=function(e){this.source!==e&&(this.source=e,this.hasAnchor&&(this._anchorCache=this._buildAnchorCache()))},e.prototype.resolveBackReferences=function(e,t){var n=t.map((function(t){return e.substring(t.start,t.end)}));return a.lastIndex=0,this.source.replace(a,(function(e,t){return(n[parseInt(t,10)]||"").replace(/[\\-\\\\\\{\\}\\*\\+\\?\\|\\^\\$\\.\\,\\[\\]\\(\\)\\#\\s]/g,"\\\\$&")}))},e.prototype._buildAnchorCache=function(){var e,t,n,r,i=[],o=[],s=[],a=[];for(e=0,t=this.source.length;e<t;e++)n=this.source.charAt(e),i[e]=n,o[e]=n,s[e]=n,a[e]=n,"\\\\"===n&&e+1<t&&("A"===(r=this.source.charAt(e+1))?(i[e+1]="￿",o[e+1]="￿",s[e+1]="A",a[e+1]="A"):"G"===r?(i[e+1]="￿",o[e+1]="G",s[e+1]="￿",a[e+1]="G"):(i[e+1]=r,o[e+1]=r,s[e+1]=r,a[e+1]=r),e++);return{A0_G0:i.join(""),A0_G1:o.join(""),A1_G0:s.join(""),A1_G1:a.join("")}},e.prototype.resolveAnchors=function(e,t){return this.hasAnchor&&this._anchorCache?e?t?this._anchorCache.A1_G1:this._anchorCache.A1_G0:t?this._anchorCache.A0_G1:this._anchorCache.A0_G0:this.source},e}();t.RegExpSource=h;var p=function(){function e(){this._items=[],this._hasAnchors=!1,this._cached=null,this._anchorCache={A0_G0:null,A0_G1:null,A1_G0:null,A1_G1:null}}return e.prototype.dispose=function(){this._disposeCaches()},e.prototype._disposeCaches=function(){this._cached&&(this._cached.dispose(),this._cached=null),this._anchorCache.A0_G0&&(this._anchorCache.A0_G0.dispose(),this._anchorCache.A0_G0=null),this._anchorCache.A0_G1&&(this._anchorCache.A0_G1.dispose(),this._anchorCache.A0_G1=null),this._anchorCache.A1_G0&&(this._anchorCache.A1_G0.dispose(),this._anchorCache.A1_G0=null),this._anchorCache.A1_G1&&(this._anchorCache.A1_G1.dispose(),this._anchorCache.A1_G1=null)},e.prototype.push=function(e){this._items.push(e),this._hasAnchors=this._hasAnchors||e.hasAnchor},e.prototype.unshift=function(e){this._items.unshift(e),this._hasAnchors=this._hasAnchors||e.hasAnchor},e.prototype.length=function(){return this._items.length},e.prototype.setSource=function(e,t){this._items[e].source!==t&&(this._disposeCaches(),this._items[e].setSource(t))},e.prototype.compile=function(e,t,n){if(this._hasAnchors)return t?n?(this._anchorCache.A1_G1||(this._anchorCache.A1_G1=this._resolveAnchors(e,t,n)),this._anchorCache.A1_G1):(this._anchorCache.A1_G0||(this._anchorCache.A1_G0=this._resolveAnchors(e,t,n)),this._anchorCache.A1_G0):n?(this._anchorCache.A0_G1||(this._anchorCache.A0_G1=this._resolveAnchors(e,t,n)),this._anchorCache.A0_G1):(this._anchorCache.A0_G0||(this._anchorCache.A0_G0=this._resolveAnchors(e,t,n)),this._anchorCache.A0_G0);if(!this._cached){var r=this._items.map((function(e){return e.source}));this._cached=new c(e,r,this._items.map((function(e){return e.ruleId})))}return this._cached},e.prototype._resolveAnchors=function(e,t,n){var r=this._items.map((function(e){return e.resolveAnchors(t,n)}));return new c(e,r,this._items.map((function(e){return e.ruleId})))},e}();t.RegExpSourceList=p;var f=function(e){function t(t,n,r,i,o){var s=e.call(this,t,n,r,null)||this;return s._match=new h(i,s.id),s.captures=o,s._cachedCompiledPatterns=null,s}return i(t,e),t.prototype.dispose=function(){this._cachedCompiledPatterns&&(this._cachedCompiledPatterns.dispose(),this._cachedCompiledPatterns=null)},Object.defineProperty(t.prototype,"debugMatchRegExp",{get:function(){return""+this._match.source},enumerable:!0,configurable:!0}),t.prototype.collectPatternsRecursive=function(e,t,n){t.push(this._match)},t.prototype.compile=function(e,t,n,r){return this._cachedCompiledPatterns||(this._cachedCompiledPatterns=new p,this.collectPatternsRecursive(e,this._cachedCompiledPatterns,!0)),this._cachedCompiledPatterns.compile(e,n,r)},t}(u);t.MatchRule=f;var d=function(e){function t(t,n,r,i,o){var s=e.call(this,t,n,r,i)||this;return s.patterns=o.patterns,s.hasMissingPatterns=o.hasMissingPatterns,s._cachedCompiledPatterns=null,s}return i(t,e),t.prototype.dispose=function(){this._cachedCompiledPatterns&&(this._cachedCompiledPatterns.dispose(),this._cachedCompiledPatterns=null)},t.prototype.collectPatternsRecursive=function(e,t,n){var r,i;for(r=0,i=this.patterns.length;r<i;r++)e.getRule(this.patterns[r]).collectPatternsRecursive(e,t,!1)},t.prototype.compile=function(e,t,n,r){return this._cachedCompiledPatterns||(this._cachedCompiledPatterns=new p,this.collectPatternsRecursive(e,this._cachedCompiledPatterns,!0)),this._cachedCompiledPatterns.compile(e,n,r)},t}(u);t.IncludeOnlyRule=d;var g=function(e){function t(t,n,r,i,o,s,a,c,u,l){var p=e.call(this,t,n,r,i)||this;return p._begin=new h(o,p.id),p.beginCaptures=s,p._end=new h(a||"￿",-1),p.endHasBackReferences=p._end.hasBackReferences,p.endCaptures=c,p.applyEndPatternLast=u||!1,p.patterns=l.patterns,p.hasMissingPatterns=l.hasMissingPatterns,p._cachedCompiledPatterns=null,p}return i(t,e),t.prototype.dispose=function(){this._cachedCompiledPatterns&&(this._cachedCompiledPatterns.dispose(),this._cachedCompiledPatterns=null)},Object.defineProperty(t.prototype,"debugBeginRegExp",{get:function(){return""+this._begin.source},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"debugEndRegExp",{get:function(){return""+this._end.source},enumerable:!0,configurable:!0}),t.prototype.getEndWithResolvedBackReferences=function(e,t){return this._end.resolveBackReferences(e,t)},t.prototype.collectPatternsRecursive=function(e,t,n){if(n){var r,i=void 0;for(i=0,r=this.patterns.length;i<r;i++)e.getRule(this.patterns[i]).collectPatternsRecursive(e,t,!1)}else t.push(this._begin)},t.prototype.compile=function(e,t,n,r){return this._cachedCompiledPatterns||(this._cachedCompiledPatterns=new p,this.collectPatternsRecursive(e,this._cachedCompiledPatterns,!0),this.applyEndPatternLast?this._cachedCompiledPatterns.push(this._end.hasBackReferences?this._end.clone():this._end):this._cachedCompiledPatterns.unshift(this._end.hasBackReferences?this._end.clone():this._end)),this._end.hasBackReferences&&(this.applyEndPatternLast?this._cachedCompiledPatterns.setSource(this._cachedCompiledPatterns.length()-1,t):this._cachedCompiledPatterns.setSource(0,t)),this._cachedCompiledPatterns.compile(e,n,r)},t}(u);t.BeginEndRule=g;var m=function(e){function t(t,n,r,i,o,s,a,c,u){var l=e.call(this,t,n,r,i)||this;return l._begin=new h(o,l.id),l.beginCaptures=s,l.whileCaptures=c,l._while=new h(a,-2),l.whileHasBackReferences=l._while.hasBackReferences,l.patterns=u.patterns,l.hasMissingPatterns=u.hasMissingPatterns,l._cachedCompiledPatterns=null,l._cachedCompiledWhilePatterns=null,l}return i(t,e),t.prototype.dispose=function(){this._cachedCompiledPatterns&&(this._cachedCompiledPatterns.dispose(),this._cachedCompiledPatterns=null),this._cachedCompiledWhilePatterns&&(this._cachedCompiledWhilePatterns.dispose(),this._cachedCompiledWhilePatterns=null)},Object.defineProperty(t.prototype,"debugBeginRegExp",{get:function(){return""+this._begin.source},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"debugWhileRegExp",{get:function(){return""+this._while.source},enumerable:!0,configurable:!0}),t.prototype.getWhileWithResolvedBackReferences=function(e,t){return this._while.resolveBackReferences(e,t)},t.prototype.collectPatternsRecursive=function(e,t,n){if(n){var r,i=void 0;for(i=0,r=this.patterns.length;i<r;i++)e.getRule(this.patterns[i]).collectPatternsRecursive(e,t,!1)}else t.push(this._begin)},t.prototype.compile=function(e,t,n,r){return this._cachedCompiledPatterns||(this._cachedCompiledPatterns=new p,this.collectPatternsRecursive(e,this._cachedCompiledPatterns,!0)),this._cachedCompiledPatterns.compile(e,n,r)},t.prototype.compileWhile=function(e,t,n,r){return this._cachedCompiledWhilePatterns||(this._cachedCompiledWhilePatterns=new p,this._cachedCompiledWhilePatterns.push(this._while.hasBackReferences?this._while.clone():this._while)),this._while.hasBackReferences&&this._cachedCompiledWhilePatterns.setSource(0,t||"￿"),this._cachedCompiledWhilePatterns.compile(e,n,r)},t}(u);t.BeginWhileRule=m;var _=function(){function e(){}return e.createCaptureRule=function(e,t,n,r,i){return e.registerRule((function(e){return new l(t,e,n,r,i)}))},e.getCompiledRuleId=function(t,n,r){return t.id||n.registerRule((function(i){if(t.id=i,t.match)return new f(t.$vscodeTextmateLocation,t.id,t.name,t.match,e._compileCaptures(t.captures,n,r));if(void 0===t.begin){t.repository&&(r=o.mergeObjects({},r,t.repository));var s=t.patterns;return void 0===s&&t.include&&(s=[{include:t.include}]),new d(t.$vscodeTextmateLocation,t.id,t.name,t.contentName,e._compilePatterns(s,n,r))}return t.while?new m(t.$vscodeTextmateLocation,t.id,t.name,t.contentName,t.begin,e._compileCaptures(t.beginCaptures||t.captures,n,r),t.while,e._compileCaptures(t.whileCaptures||t.captures,n,r),e._compilePatterns(t.patterns,n,r)):new g(t.$vscodeTextmateLocation,t.id,t.name,t.contentName,t.begin,e._compileCaptures(t.beginCaptures||t.captures,n,r),t.end,e._compileCaptures(t.endCaptures||t.captures,n,r),t.applyEndPatternLast,e._compilePatterns(t.patterns,n,r))})),t.id},e._compileCaptures=function(t,n,r){var i=[];if(t){var o=0;for(var s in t){if("$vscodeTextmateLocation"!==s)(c=parseInt(s,10))>o&&(o=c)}for(var a=0;a<=o;a++)i[a]=null;for(var s in t)if("$vscodeTextmateLocation"!==s){var c=parseInt(s,10),u=0;t[s].patterns&&(u=e.getCompiledRuleId(t[s],n,r)),i[c]=e.createCaptureRule(n,t[s].$vscodeTextmateLocation,t[s].name,t[s].contentName,u)}}return i},e._compilePatterns=function(t,n,r){var i=[];if(t)for(var o=0,s=t.length;o<s;o++){var a=t[o],c=-1;if(a.include)if("#"===a.include.charAt(0)){var u=r[a.include.substr(1)];u&&(c=e.getCompiledRuleId(u,n,r))}else if("$base"===a.include||"$self"===a.include)c=e.getCompiledRuleId(r[a.include],n,r);else{var l=null,h=null,p=a.include.indexOf("#");p>=0?(l=a.include.substring(0,p),h=a.include.substring(p+1)):l=a.include;var f=n.getExternalGrammar(l,r);if(f)if(h){var _=f.repository[h];_&&(c=e.getCompiledRuleId(_,n,f.repository))}else c=e.getCompiledRuleId(f.repository.$self,n,f.repository)}else c=e.getCompiledRuleId(a,n,r);if(-1!==c){var y=n.getRule(c),v=!1;if((y instanceof d||y instanceof g||y instanceof m)&&y.hasMissingPatterns&&0===y.patterns.length&&(v=!0),v)continue;i.push(c)}}return{patterns:i,hasMissingPatterns:(t?t.length:0)!==i.length}},e}();t.RuleFactory=_},function(e,t,n){"use strict";function r(e){return!!e&&!!e.match(/[\\w\\.:]+/)}Object.defineProperty(t,"__esModule",{value:!0}),t.createMatchers=function(e,t){for(var n,i,o,s=[],a=(o=(i=/([LR]:|[\\w\\.:][\\w\\.:\\-]*|[\\,\\|\\-\\(\\)])/g).exec(n=e),{next:function(){if(!o)return null;var e=o[0];return o=i.exec(n),e}}),c=a.next();null!==c;){var u=0;if(2===c.length&&":"===c.charAt(1)){switch(c.charAt(0)){case"R":u=1;break;case"L":u=-1;break;default:console.log("Unknown priority "+c+" in scope selector")}c=a.next()}var l=p();if(s.push({matcher:l,priority:u}),","!==c)break;c=a.next()}return s;function h(){if("-"===c){c=a.next();var e=h();return function(t){return!!e&&!e(t)}}if("("===c){c=a.next();var n=function(){var e=[],t=p();for(;t&&(e.push(t),"|"===c||","===c);){do{c=a.next()}while("|"===c||","===c);t=p()}return function(t){return e.some((function(e){return e(t)}))}}();return")"===c&&(c=a.next()),n}if(r(c)){var i=[];do{i.push(c),c=a.next()}while(r(c));return function(e){return t(i,e)}}return null}function p(){for(var e=[],t=h();t;)e.push(t),t=h();return function(t){return e.every((function(e){return e(t)}))}}}},function(e,t){var n,r,i=e.exports={};function o(){throw new Error("setTimeout has not been defined")}function s(){throw new Error("clearTimeout has not been defined")}function a(e){if(n===setTimeout)return setTimeout(e,0);if((n===o||!n)&&setTimeout)return n=setTimeout,setTimeout(e,0);try{return n(e,0)}catch(t){try{return n.call(null,e,0)}catch(t){return n.call(this,e,0)}}}!function(){try{n="function"==typeof setTimeout?setTimeout:o}catch(e){n=o}try{r="function"==typeof clearTimeout?clearTimeout:s}catch(e){r=s}}();var c,u=[],l=!1,h=-1;function p(){l&&c&&(l=!1,c.length?u=c.concat(u):h=-1,u.length&&f())}function f(){if(!l){var e=a(p);l=!0;for(var t=u.length;t;){for(c=u,u=[];++h<t;)c&&c[h].run();h=-1,t=u.length}c=null,l=!1,function(e){if(r===clearTimeout)return clearTimeout(e);if((r===s||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(e);try{r(e)}catch(t){try{return r.call(null,e)}catch(t){return r.call(this,e)}}}(e)}}function d(e,t){this.fun=e,this.array=t}function g(){}i.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];u.push(new d(e,t)),1!==u.length||l||a(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},i.title="browser",i.browser=!0,i.env={},i.argv=[],i.version="",i.versions={},i.on=g,i.addListener=g,i.once=g,i.off=g,i.removeListener=g,i.removeAllListeners=g,i.emit=g,i.prependListener=g,i.prependOnceListener=g,i.listeners=function(e){return[]},i.binding=function(e){throw new Error("process.binding is not supported")},i.cwd=function(){return"/"},i.chdir=function(e){throw new Error("process.chdir is not supported")},i.umask=function(){return 0}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(9),i=n(2),o=n(10);t.parseRawGrammar=function(e,t){return void 0===t&&(t=null),null!==t&&/\\.json$/.test(t)?function(e,t){if(i.DebugFlags.InDebugMode)return o.parse(e,t,!0);return JSON.parse(e)}(e,t):function(e,t){if(i.DebugFlags.InDebugMode)return r.parseWithLocation(e,t,"$vscodeTextmateLocation");return r.parse(e)}(e,t)}},function(e,t,n){"use strict";function r(e,t,n){var r=e.length,i=0,o=1,s=0;function a(t){if(null===n)i+=t;else for(;t>0;){10===e.charCodeAt(i)?(i++,o++,s=0):(i++,s++),t--}}function c(e){null===n?i=e:a(e-i)}function u(){for(;i<r;){var t=e.charCodeAt(i);if(32!==t&&9!==t&&13!==t&&10!==t)break;a(1)}}function l(t){return e.substr(i,t.length)===t&&(a(t.length),!0)}function h(t){var n=e.indexOf(t,i);c(-1!==n?n+t.length:r)}function p(t){var n=e.indexOf(t,i);if(-1!==n){var o=e.substring(i,n);return c(n+t.length),o}o=e.substr(i);return c(r),o}r>0&&65279===e.charCodeAt(0)&&(i=1);var f=0,d=null,g=[],m=[],_=null;function y(e,t){g.push(f),m.push(d),f=e,d=t}function v(){if(0===g.length)return b("illegal state stack");f=g.pop(),d=m.pop()}function b(t){throw new Error("Near offset "+i+": "+t+" ~~~"+e.substr(i,50)+"~~~")}var C,w,k,R=function(){if(null===_)return b("missing <key>");var e={};null!==n&&(e[n]={filename:t,line:o,char:s}),d[_]=e,_=null,y(1,e)},S=function(){if(null===_)return b("missing <key>");var e=[];d[_]=e,_=null,y(2,e)},P=function(){var e={};null!==n&&(e[n]={filename:t,line:o,char:s}),d.push(e),y(1,e)},x=function(){var e=[];d.push(e),y(2,e)};function I(){if(1!==f)return b("unexpected </dict>");v()}function A(){return 1===f||2!==f?b("unexpected </array>"):void v()}function T(e){if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function L(e){if(isNaN(e))return b("cannot parse float");if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function M(e){if(isNaN(e))return b("cannot parse integer");if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function G(e){if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function D(e){if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function N(e){if(1===f){if(null===_)return b("missing <key>");d[_]=e,_=null}else 2===f?d.push(e):d=e}function E(e){if(e.isClosed)return"";var t=p("</");return h(">"),t.replace(/&#([0-9]+);/g,(function(e,t){return String.fromCodePoint(parseInt(t,10))})).replace(/&#x([0-9a-f]+);/g,(function(e,t){return String.fromCodePoint(parseInt(t,16))})).replace(/&amp;|&lt;|&gt;|&quot;|&apos;/g,(function(e){switch(e){case"&amp;":return"&";case"&lt;":return"<";case"&gt;":return">";case"&quot;":return\'"\';case"&apos;":return"\'"}return e}))}for(;i<r&&(u(),!(i>=r));){var O=e.charCodeAt(i);if(a(1),60!==O)return b("expected <");if(i>=r)return b("unexpected end of input");var j=e.charCodeAt(i);if(63!==j)if(33!==j){if(47===j){if(a(1),u(),l("plist")){h(">");continue}if(l("dict")){h(">"),I();continue}if(l("array")){h(">"),A();continue}return b("unexpected closed tag")}var F=(w=void 0,k=void 0,w=p(">"),k=!1,47===w.charCodeAt(w.length-1)&&(k=!0,w=w.substring(0,w.length-1)),{name:w.trim(),isClosed:k});switch(F.name){case"dict":1===f?R():2===f?P():(d={},null!==n&&(d[n]={filename:t,line:o,char:s}),y(1,d)),F.isClosed&&I();continue;case"array":1===f?S():2===f?x():y(2,d=[]),F.isClosed&&A();continue;case"key":C=E(F),1!==f?b("unexpected <key>"):null!==_?b("too many <key>"):_=C;continue;case"string":T(E(F));continue;case"real":L(parseFloat(E(F)));continue;case"integer":M(parseInt(E(F),10));continue;case"date":G(new Date(E(F)));continue;case"data":D(E(F));continue;case"true":E(F),N(!0);continue;case"false":E(F),N(!1);continue}if(!/^plist/.test(F.name))return b("unexpected opened tag "+F.name)}else{if(a(1),l("--")){h("--\\x3e");continue}h(">")}else a(1),h("?>")}return d}Object.defineProperty(t,"__esModule",{value:!0}),t.parseWithLocation=function(e,t,n){return r(e,t,n)},t.parse=function(e){return r(e,null,null)}},function(e,t,n){"use strict";function r(e,t){throw new Error("Near offset "+e.pos+": "+t+" ~~~"+e.source.substr(e.pos,50)+"~~~")}Object.defineProperty(t,"__esModule",{value:!0}),t.parse=function(e,t,n){var a=new i(e),c=new o,u=0,l=null,h=[],p=[];function f(){h.push(u),p.push(l)}function d(){u=h.pop(),l=p.pop()}function g(e){r(a,e)}for(;s(a,c);){if(0===u){if(null!==l&&g("too many constructs in root"),3===c.type){l={},n&&(l.$vscodeTextmateLocation=c.toLocation(t)),f(),u=1;continue}if(2===c.type){l=[],f(),u=4;continue}g("unexpected token in root")}if(2===u){if(5===c.type){d();continue}if(7===c.type){u=3;continue}g("expected , or }")}if(1===u||3===u){if(1===u&&5===c.type){d();continue}if(1===c.type){var m=c.value;if(s(a,c)&&6===c.type||g("expected colon"),s(a,c)||g("expected value"),u=2,1===c.type){l[m]=c.value;continue}if(8===c.type){l[m]=null;continue}if(9===c.type){l[m]=!0;continue}if(10===c.type){l[m]=!1;continue}if(11===c.type){l[m]=parseFloat(c.value);continue}if(2===c.type){var _=[];l[m]=_,f(),u=4,l=_;continue}if(3===c.type){var y={};n&&(y.$vscodeTextmateLocation=c.toLocation(t)),l[m]=y,f(),u=1,l=y;continue}}g("unexpected token in dict")}if(5===u){if(4===c.type){d();continue}if(7===c.type){u=6;continue}g("expected , or ]")}if(4===u||6===u){if(4===u&&4===c.type){d();continue}if(u=5,1===c.type){l.push(c.value);continue}if(8===c.type){l.push(null);continue}if(9===c.type){l.push(!0);continue}if(10===c.type){l.push(!1);continue}if(11===c.type){l.push(parseFloat(c.value));continue}if(2===c.type){_=[];l.push(_),f(),u=4,l=_;continue}if(3===c.type){y={};n&&(y.$vscodeTextmateLocation=c.toLocation(t)),l.push(y),f(),u=1,l=y;continue}g("unexpected token in array")}g("unknown state")}return 0!==p.length&&g("unclosed constructs"),l};var i=function(e){this.source=e,this.pos=0,this.len=e.length,this.line=1,this.char=0},o=function(){function e(){this.value=null,this.type=0,this.offset=-1,this.len=-1,this.line=-1,this.char=-1}return e.prototype.toLocation=function(e){return{filename:e,line:this.line,char:this.char}},e}();function s(e,t){t.value=null,t.type=0,t.offset=-1,t.len=-1,t.line=-1,t.char=-1;for(var n,i=e.source,o=e.pos,s=e.len,a=e.line,c=e.char;;){if(o>=s)return!1;if(32!==(n=i.charCodeAt(o))&&9!==n&&13!==n){if(10!==n)break;o++,a++,c=0}else o++,c++}if(t.offset=o,t.line=a,t.char=c,34===n){for(t.type=1,o++,c++;;){if(o>=s)return!1;if(n=i.charCodeAt(o),o++,c++,92!==n){if(34===n)break}else o++,c++}t.value=i.substring(t.offset+1,o-1).replace(/\\\\u([0-9A-Fa-f]{4})/g,(function(e,t){return String.fromCodePoint(parseInt(t,16))})).replace(/\\\\(.)/g,(function(t,n){switch(n){case\'"\':return\'"\';case"\\\\":return"\\\\";case"/":return"/";case"b":return"\\b";case"f":return"\\f";case"n":return"\\n";case"r":return"\\r";case"t":return"\\t";default:r(e,"invalid escape sequence")}throw new Error("unreachable")}))}else if(91===n)t.type=2,o++,c++;else if(123===n)t.type=3,o++,c++;else if(93===n)t.type=4,o++,c++;else if(125===n)t.type=5,o++,c++;else if(58===n)t.type=6,o++,c++;else if(44===n)t.type=7,o++,c++;else if(110===n){if(t.type=8,o++,c++,117!==(n=i.charCodeAt(o)))return!1;if(o++,c++,108!==(n=i.charCodeAt(o)))return!1;if(o++,c++,108!==(n=i.charCodeAt(o)))return!1;o++,c++}else if(116===n){if(t.type=9,o++,c++,114!==(n=i.charCodeAt(o)))return!1;if(o++,c++,117!==(n=i.charCodeAt(o)))return!1;if(o++,c++,101!==(n=i.charCodeAt(o)))return!1;o++,c++}else if(102===n){if(t.type=10,o++,c++,97!==(n=i.charCodeAt(o)))return!1;if(o++,c++,108!==(n=i.charCodeAt(o)))return!1;if(o++,c++,115!==(n=i.charCodeAt(o)))return!1;if(o++,c++,101!==(n=i.charCodeAt(o)))return!1;o++,c++}else for(t.type=11;;){if(o>=s)return!1;if(!(46===(n=i.charCodeAt(o))||n>=48&&n<=57||101===n||69===n||45===n||43===n))break;o++,c++}return t.len=o-t.offset,null===t.value&&(t.value=i.substr(t.offset,t.len)),e.pos=o,e.line=a,e.char=c,!0}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(e,t,n,r,i,o){this.scope=e,this.parentScopes=t,this.index=n,this.fontStyle=r,this.foreground=i,this.background=o};function i(e){return!!/^#[0-9a-f]{6}$/i.test(e)||(!!/^#[0-9a-f]{8}$/i.test(e)||(!!/^#[0-9a-f]{3}$/i.test(e)||!!/^#[0-9a-f]{4}$/i.test(e)))}function o(e){if(!e)return[];if(!e.settings||!Array.isArray(e.settings))return[];for(var t=e.settings,n=[],o=0,s=0,a=t.length;s<a;s++){var c=t[s];if(c.settings){var u=void 0;if("string"==typeof c.scope)u=c.scope.replace(/^[,]+/,"").replace(/[,]+$/,"").split(",");else u=Array.isArray(c.scope)?c.scope:[""];var l=-1;if("string"==typeof c.settings.fontStyle){l=0;for(var h=0,p=(g=c.settings.fontStyle.split(" ")).length;h<p;h++){switch(g[h]){case"italic":l|=1;break;case"bold":l|=2;break;case"underline":l|=4}}}var f=null;"string"==typeof c.settings.foreground&&i(c.settings.foreground)&&(f=c.settings.foreground);var d=null;"string"==typeof c.settings.background&&i(c.settings.background)&&(d=c.settings.background);for(h=0,p=u.length;h<p;h++){var g,m=(g=u[h].trim().split(" "))[g.length-1],_=null;g.length>1&&(_=g.slice(0,g.length-1)).reverse(),n[o++]=new r(m,_,s,l,f,d)}}}return n}function s(e,t){e.sort((function(e,t){var n=u(e.scope,t.scope);return 0!==n||0!==(n=l(e.parentScopes,t.parentScopes))?n:e.index-t.index}));for(var n=0,r="#000000",i="#ffffff";e.length>=1&&""===e[0].scope;){var o=e.shift();-1!==o.fontStyle&&(n=o.fontStyle),null!==o.foreground&&(r=o.foreground),null!==o.background&&(i=o.background)}for(var s=new a(t),f=new h(0,null,n,s.getId(r),s.getId(i)),d=new p(new h(0,null,-1,0,0),[]),g=0,m=e.length;g<m;g++){var _=e[g];d.insert(0,_.scope,_.parentScopes,_.fontStyle,s.getId(_.foreground),s.getId(_.background))}return new c(s,f,d)}t.ParsedThemeRule=r,t.parseTheme=o;var a=function(){function e(e){if(this._lastColorId=0,this._id2color=[],this._color2id=Object.create(null),Array.isArray(e)){this._isFrozen=!0;for(var t=0,n=e.length;t<n;t++)this._color2id[e[t]]=t,this._id2color[t]=e[t]}else this._isFrozen=!1}return e.prototype.getId=function(e){if(null===e)return 0;e=e.toUpperCase();var t=this._color2id[e];if(t)return t;if(this._isFrozen)throw new Error("Missing color in color map - "+e);return t=++this._lastColorId,this._color2id[e]=t,this._id2color[t]=e,t},e.prototype.getColorMap=function(){return this._id2color.slice(0)},e}();t.ColorMap=a;var c=function(){function e(e,t,n){this._colorMap=e,this._root=n,this._defaults=t,this._cache={}}return e.createFromRawTheme=function(e,t){return this.createFromParsedTheme(o(e),t)},e.createFromParsedTheme=function(e,t){return s(e,t)},e.prototype.getColorMap=function(){return this._colorMap.getColorMap()},e.prototype.getDefaults=function(){return this._defaults},e.prototype.match=function(e){return this._cache.hasOwnProperty(e)||(this._cache[e]=this._root.match(e)),this._cache[e]},e}();function u(e,t){return e<t?-1:e>t?1:0}function l(e,t){if(null===e&&null===t)return 0;if(!e)return-1;if(!t)return 1;var n=e.length,r=t.length;if(n===r){for(var i=0;i<n;i++){var o=u(e[i],t[i]);if(0!==o)return o}return 0}return n-r}t.Theme=c,t.strcmp=u,t.strArrCmp=l;var h=function(){function e(e,t,n,r,i){this.scopeDepth=e,this.parentScopes=t,this.fontStyle=n,this.foreground=r,this.background=i}return e.prototype.clone=function(){return new e(this.scopeDepth,this.parentScopes,this.fontStyle,this.foreground,this.background)},e.cloneArr=function(e){for(var t=[],n=0,r=e.length;n<r;n++)t[n]=e[n].clone();return t},e.prototype.acceptOverwrite=function(e,t,n,r){this.scopeDepth>e?console.log("how did this happen?"):this.scopeDepth=e,-1!==t&&(this.fontStyle=t),0!==n&&(this.foreground=n),0!==r&&(this.background=r)},e}();t.ThemeTrieElementRule=h;var p=function(){function e(e,t,n){void 0===t&&(t=[]),void 0===n&&(n={}),this._mainRule=e,this._rulesWithParentScopes=t,this._children=n}return e._sortBySpecificity=function(e){return 1===e.length||e.sort(this._cmpBySpecificity),e},e._cmpBySpecificity=function(e,t){if(e.scopeDepth===t.scopeDepth){var n=e.parentScopes,r=t.parentScopes,i=null===n?0:n.length,o=null===r?0:r.length;if(i===o)for(var s=0;s<i;s++){var a=n[s].length,c=r[s].length;if(a!==c)return c-a}return o-i}return t.scopeDepth-e.scopeDepth},e.prototype.match=function(t){if(""===t)return e._sortBySpecificity([].concat(this._mainRule).concat(this._rulesWithParentScopes));var n,r,i=t.indexOf(".");return-1===i?(n=t,r=""):(n=t.substring(0,i),r=t.substring(i+1)),this._children.hasOwnProperty(n)?this._children[n].match(r):e._sortBySpecificity([].concat(this._mainRule).concat(this._rulesWithParentScopes))},e.prototype.insert=function(t,n,r,i,o,s){if(""!==n){var a,c,u,l=n.indexOf(".");-1===l?(a=n,c=""):(a=n.substring(0,l),c=n.substring(l+1)),this._children.hasOwnProperty(a)?u=this._children[a]:(u=new e(this._mainRule.clone(),h.cloneArr(this._rulesWithParentScopes)),this._children[a]=u),u.insert(t+1,c,r,i,o,s)}else this._doInsertHere(t,r,i,o,s)},e.prototype._doInsertHere=function(e,t,n,r,i){if(null!==t){for(var o=0,s=this._rulesWithParentScopes.length;o<s;o++){var a=this._rulesWithParentScopes[o];if(0===l(a.parentScopes,t))return void a.acceptOverwrite(e,n,r,i)}-1===n&&(n=this._mainRule.fontStyle),0===r&&(r=this._mainRule.foreground),0===i&&(i=this._mainRule.background),this._rulesWithParentScopes.push(new h(e,t,n,r,i))}else this._mainRule.acceptOverwrite(e,n,r,i)},e}();t.ThemeTrieElement=p}])}));\n//# sourceMappingURL=main.js.map\n\n//# sourceURL=webpack://froala-syntax-highlighter/./node_modules/vscode-textmate/release/main.js?')},"?2208":()=>{eval("/* (ignored) */\n\n//# sourceURL=webpack://froala-syntax-highlighter/fs_(ignored)?")},"?54c7":()=>{eval("/* (ignored) */\n\n//# sourceURL=webpack://froala-syntax-highlighter/path_(ignored)?")}},__webpack_module_cache__={};function __webpack_require__(e){var n=__webpack_module_cache__[e];if(void 0!==n)return n.exports;var t=__webpack_module_cache__[e]={exports:{}};return __webpack_modules__[e].call(t.exports,t,t.exports,__webpack_require__),t.exports}__webpack_require__.n=e=>{var n=e&&e.__esModule?()=>e.default:()=>e;return __webpack_require__.d(n,{a:n}),n},__webpack_require__.d=(e,n)=>{for(var t in n)__webpack_require__.o(n,t)&&!__webpack_require__.o(e,t)&&Object.defineProperty(e,t,{enumerable:!0,get:n[t]})},__webpack_require__.o=(e,n)=>Object.prototype.hasOwnProperty.call(e,n),__webpack_require__.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})};var __webpack_exports__=__webpack_require__("./src/index.ts")})();